*-------------------------------------------------------------------------
*         Copyright (c) 1992 Borland International, Inc.
*
* Borland grants you permission to use, modify, reproduce and
* distribute this Control Center Booster as a part of programs
* or applications you write, without additional license or fees,
* subject to the following conditions:
* 
* - All copies of your program or application must bear a valid 
*   copyright notice.  By "copyright notice," we mean either your
*   own copyright notice or the Borland copyright notice shown
*   above.
* 
* - Borland provides no warranties or guarantees with respect to
*   the Control Center Booster other than the Limited Warranty
*   provided in this package to the original purchaser.
* 
* - You will remain solely responsible to anyone receiving the 
*   program or application for any support, service, upgrades or
*   technical or other assistance, and such recipients will have no
*   right to contact Borland for such services or assistance.  You
*   will indemnify and hold Borland harmless from and against any
*   claims or liabilities arising out of the use, reproduction or
*   distribution of the Control Center Booster.
* 
* - Your program or application may not merely be the Control Center
*   Booster itself or a competitive product.
*-------------------------------------------------------------------------

FUNCTION AFields    && Fill an Array With Fields of DBF
PARAMETERS type_call, m_buffer
********************************************************************************
* PROGRAM: AFIELDS.PRG
*    DATE: 8/19/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S AFIELDS() FUNCTION
*
*  PARAM1: TYPE OF CALL
*  PARAM2: STRING BUFFER FROM PREVIOUS TYPE 1 CALL
* RETURNS: RETURN VALUES FOR EACH TYPE OF CALL ARE LISTED BELOW
*          1 - BUFFER CONTAINING FIRST OR NEXT LINE OF DBF STRUCTURE LISTING
*          2 - FIELD NAME FROM STRUCTURE LISTING BUFFER
*          3 - FIELD TYPE FROM STRUCTURE LISTING BUFFER
*          4 - FIELD WIDTH (NUMERIC) FROM STRUCTURE LISTING BUFFER
*          5 - FIELD DECIMALS (NUMERIC) FROM STRUCTURE LISTING BUFFER
*
********************************************************************************
  PRIVATE m_temp, m_count

  IF TYPE('m_handle') = 'U'
    PUBLIC m_handle
    m_handle = 0
  ENDIF

  DO CASE

    CASE type_call = 1
      * RETURN BUFFER CONTAINING FIRST OR NEXT LINE OF DBF STRUCTURE LISTING
      IF LEN(m_buffer) = 0
        IF LEN(DBF()) = 0
        RETURN ""
      ENDIF
      m_temp = set('CONSOLE')
      SET CONSOLE OFF
      LIST STRUCTURE TO FILE stepwrk.wrk
      IF m_temp = 'ON'
        SET CONSOLE ON
      ENDIF
      m_handle = fopen("STEPWRK.WRK",0)
      m_buffer = " "
      m_temp = 0
      m_count = 0
      DO WHILE m_count < 5
        m_temp = AT(CHR(13),m_buffer)
        IF m_temp = 0
          m_buffer = SPACE(101)
          m_buffer = fread(m_handle,100)
        ELSE
          m_count = m_count + 1
          m_buffer = SUBSTR(m_buffer,m_temp+1)
        ENDIF
      ENDDO
      m_buffer = SUBSTR(m_buffer,2) + fread(m_handle,54-LEN(m_buffer))
    ELSE
      m_buffer = SPACE(54)
      m_buffer = fread(m_handle,53)
    ENDIF
    IF LEN(m_buffer) = 53
      RETURN m_buffer
    ELSE
      m_count = fclose(m_handle)
      RETURN ""
    ENDIF

  CASE type_call = 2
    * RETURN FIELD NAME FROM STRUCTURE LISTING BUFFER
    RETURN TRIM(SUBSTR(m_buffer,8,10))

  CASE type_call = 3
    * RETURN FIELD TYPE FROM STRUCTURE LISTING BUFFER
    RETURN SUBSTR(m_buffer,20,1)

  CASE type_call = 4
    * RETURN FIELD WIDTH FROM STRUCTURE LISTING BUFFER
    RETURN VAL(SUBSTR(m_buffer,33,3))

  CASE type_call = 5
    * RETURN FIELD DECIMALS FROM STRUCTURE LISTING BUFFER
    RETURN VAL(SUBSTR(m_buffer,41,2))

ENDCASE

RETURN ""
*-- EOF: AFields(type_call, m_buffer)


FUNCTION AllTrim    && Trim Blanks Before and After a String
PARAMETER lc_string
*-----------------------------------------------------------------------------
* Synopsis:
* 
* ALLTRIM( <expC> )
* 
* The ALLTRIM() function returns the given character expression <expC> with
* all leading and trailing blanks removed.  If the <expC> is a numeric type,
* ALLTRIM() will return a trimed string back.  If a memo field is used, a null
* string is returned.  If a logical value is used, the string ".T." or ".F."
* will be returned.
* 
* See also:  LTRIM(), RTRIM(), TRIM()
* 
*-----------------------------------------------------------------------------
PRIVATE lc_return, lc_type

lc_type = TYPE("lc_string")
DO CASE
  CASE lc_type = "C"
    lc_return = LTRIM( RTRIM( lc_string ) )
  CASE lc_type $ "NF"
    lc_return = LTRIM( RTRIM( STR(lc_string) ) )
  CASE lc_type = "L"
    IF lc_string
      lc_return = "T"
    ELSE
      lc_return = "F"
    ENDIF
  OTHERWISE                          
    lc_return = ""
ENDCASE
RETURN ( lc_return )
*-- EOP: AllTrim( lc_string )


FUNCTION ASort      && Sort an Array of Values
PARAMETERS calltype, value
********************************************************************************
* PROGRAM: ASORT.PRG
*    DATE: 8/22/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S ASORT() FUNCTION
*
*  PARAM1: TYPE OF CALL (1-POST TO SORT; 2-RETRIEVE FROM SORT)
*  PARAM2: VALUE TO POST TO SORT FOR CALL TYPE 1
*          SEQUENTIAL NUMBER ON TYPE 2 CALLS (STARTING WITH 1)
* RETURNS: RETURNS NEXT SORT VALUE IN SEQUENCE FOR CALL TYPE 2
*
********************************************************************************
  PRIVATE mtemp, mtemp2

  IF TYPE('m_sortarr[1]') = 'U'
    IF calltype = 1
      PUBLIC array m_sortarr[50]
      PUBLIC m_sortcnt
      m_sortcnt = 1
      m_sortarr[1] = value
    RETURN m_sortcnt
  ELSE
    RETURN .F.
  ENDIF
ENDIF

IF calltype = 1
  mtemp2 = 0
  mtemp = 1
  DO WHILE mtemp <= m_sortcnt .AND. mtemp2 = 0
    IF value <= m_sortarr[mtemp]
      * FOUND WHERE IT GOES - MOVE REST DOWN AND INSERT IT
      mtemp2 = m_sortcnt
      DO WHILE mtemp2 >= mtemp
        m_sortarr[mtemp2+1] = m_sortarr[mtemp2]
        mtemp2 = mtemp2 - 1
      ENDDO
      mtemp2 = -1
      m_sortarr[mtemp] = value
    ENDIF
    mtemp = mtemp + 1
  ENDDO
  m_sortcnt = m_sortcnt + 1
  IF mtemp2 = 0
    * ADD IT TO THE END
    m_sortarr[m_sortcnt] = value
  ENDIF
  RETURN m_sortcnt
ENDIF

IF calltype = 2
  IF value > m_sortcnt
    RETURN ""
  ENDIF
  mtemp = m_sortarr[value]
  IF value >= m_sortcnt
    RELEASE m_sortcnt, m_sortarr
  ENDIF
  RETURN mtemp
ENDIF

RETURN .F.
*-- EOF: ASort( calltype, value )


FUNCTION Center     && Provide column needed to center a string in a width
PARAMETER lc_string, ln_width
*-----------------------------------------------------------------------------
* Synopsis:
* 
* CENTER( <expC>, <expN> )
* 
* The CENTER() function will return the starting column coordinate to center
* the <expC> string within a width of screen <expN>.  The width of the screen
* would normally be 80 colunms, but could just as well be the width of a 
* window.  If there is an error condition, the returned result will equal 0.
* If a numeric value is passed for the <expC> value, it will be converted
* to a string.
* 
* Examples:
* 
*   @ 15,center(string,80) say string    
* 
* Will center the <string> withing 80 columns
* 
*-----------------------------------------------------------------------------
PRIVATE lc_result, lc_type

IF .NOT. TYPE("ln_width") $ "FN"       && Force value to 0 for bad type
  lc_result = 0
ELSE

  lc_type = TYPE("lc_string")
  DO CASE
    CASE lc_type = "C"
      lc_width = (ln_width/2)-(LEN(lc_string)/2)
    CASE lc_type $ "NF"
      lc_width = (ln_width/2)-(LEN(ALLTRIM(STR(lc_string)))/2)
    CASE lc_type = "L"
      lc_width = (ln_width/2)-(1.5)    && .T. or .F. have fixed len of 3
    OTHERWISE                          
      lc_width = 0
  ENDCASE
ENDIF

IF lc_width < 0                        && Force negative values to 0
  lc_width = 0
ENDIF

RETURN ( lc_width )
*-- EOF: Center( lc_string, ln_width )


FUNCTION Chk4Num    && Check to see if a field is a numeric/float
PARAMETER pn_fld
*-------------------------------------------------------------------
* Make sure that the parameter is a numeric value
*-------------------------------------------------------------------
  PRIVATE ll_result

  ll_result = .F.             && Assume the worst, it's not numeric
  IF TYPE( PN_FLD ) $ "NF"
    ll_result = .T.
  ENDIF

RETURN( ll_result )
*-- EOF: Chk4Num( pn_fld )


FUNCTION Color      && Retrieve or Set Color Attributes
PARAMETERS set_color
*-----------------------------------------------------------------------------
* Synopsis:
* 
* COLOR( <expC> )
*  <expC> = NORMAL, HIGHLIGHT, MESSAGES, TITLES, BOX, INFORMATION, FIELDS, COLOR
*        or a variable with all colors store in it
*  Ver: dBASE 1.1
*
* The COLOR() function either returns or sets colors returned with the
* SET("attribute") setting
* If <expC> is a color string then null is returned otherwise the color
* setting is returned for one of dBASE's color options
*
* Example:
*
*   lc_prevcol = SET("ATTRIBUTE")    && Save current colors
*   SET COLOR TO w+/b,gr+/n          && Change standard colors
*   SET COLOR OF INFORMATION TO w+/r && Change INFORMATION colors
*   ...
*   lc_tmp = COLOR("lc_prevcol")     && Restore colors back to before
*
*   lc_high = COLOR("HIGHLIGHT")     && Capture color of the HIGHLIGHT
* 
* See Also: SET("attribute")
* 
* Author: Kirk Nason
*-----------------------------------------------------------------------------
PRIVATE color_num, color_str, cnt, old_talk
DO Talkoff

IF "" = set_color .OR. "HELP" $ UPPER(set_color) 
  ? "Try:"
  ? ""
  DO Talkon
  RETURN "COLOR; NORMAL, HIGHLIGHT, BORDER;  MESSAGES, TITLES, BOX, INFORMATION, FIELDS"
ENDIF

set_color = UPPER(set_color)
IF set_color $ "COLOR"
  *- Return standard, enhanced, border colors only
  RETURN LEFT( SET("attribute"), AT(" &", SET("attribute") ) )
ENDIF

*- Declare array to parse color options from SET("attr")
PRIVATE color_
DECLARE color_[8]
*- Determine if user is restoring colors vs. saving colors
IF " &" $ set_color
  color_str = ","+set_color+","                  && Restore color attributes
ELSE
  color_str = ","+SET("ATTRIBUTE")+","           && Save color attributes
ENDIF

*-- Stuff array with individual color setting

color_str = STUFF(color_str, AT(" &", color_str), 4, ",")
cnt = 1
DO WHILE cnt <= 8                                && Pick out individual colors
  color_str = SUBSTR(color_str, AT(",", color_str ) + 1 )
  color_[cnt] = SUBSTR(color_str, 1, AT(",", color_str ) - 1)
  cnt = cnt + 1
ENDDO

IF " &" $ set_color                              && Have the string from SET("attribute")
  *-- Set color back
  SET COLOR TO ,,&color_[3].
  SET COLOR OF NORMAL TO &color_[1].
  SET COLOR OF HIGHLIGHT TO &color_[2].
  SET COLOR OF MESSAGES TO &color_[4].
  SET COLOR OF TITLES TO &color_[5].
  SET COLOR OF BOX TO &color_[6].
  SET COLOR OF INFORMATION TO &color_[7].
  SET COLOR OF FIELDS TO &color_[8].
ELSE
  *-- Return color string requested
  DO CASE
  CASE set_color $ "NORMAL"
    color_num =  1
  CASE set_color $ "HIGHLIGHT"
    color_num =  2
  CASE set_color $ "BORDER"
    color_num =  3
  CASE set_color $ "MESSAGES"
    color_num =  4
  CASE set_color $ "TITLES"
    color_num =  5
  CASE set_color $ "BOX"
    color_num =  6
  CASE set_color $ "INFORMATION"
    color_num =  7
  CASE set_color $ "FIELDS"
    color_num =  8
  OTHERWISE
    set_color = " &"
  ENDCASE
ENDIF
DO Talkon
RETURN IIF(" &" $ set_color, "", color_[color_num])
*-- EOF: Color( set_color )


FUNCTION CurDir     && Return the current DOS directory
PARAMETER pc_drive
*-----------------------------------------------------------
* Returns the current DOS directory
*
* Synopsis:
*
* CURDIR( <expC> )
*
* Description:
*
* CURDIR() returns the current DOS directory in effect 
* on the drive identified by <expC>.  The value returned is
* a character string.  The current default drive is
* assumed (dBASE IV's SET DEFAULT drive) if <expC> is null.  
* CURDIR will returna null string if no <expC> drive exists.
*
* CURDIR() ignores the dBASE IV's SET PATH values.
*
* Examples:
*
*     ? CURDIR('')
*     
*     RUN CD \DBASE\SAMPLES
*     ? CURDIR('C')
*     
*     SET DEFAULT TO C:\
*     ? CURDIR('C')		&& root
*     
*     
*     IF .NOT. CURDIR('C') = 'DBASE\SAMPLES\'
*        SET DEFAULT TO C:
*        RUN CD \DBASE\SAMPLES
*     ENDIF
*
* In the second program example, CURDIR() looks to see if
* the current directory for the C drive is \DBASE\SAMPLES. 
* If not, it sets the default to that directory.
*
* Warning: CURDIR.BIN must be loaded before the call.  Use
*          the following procedure to load and release the
*          BIN file.
*
*          DO Load_Bin WITH "curdir"
*          ...  Code to execute CurDir()
*          DO Rele_Bin WITH "curdir"
*
*-----------------------------------------------------------
PRIVATE lc_return

  lc_return = ""

  IF glcurdir     && BIN file correctly LOADed with LOAD_BIN

    IF ISBLANK( pc_drive )
      IF glgetdrive
        pc_drive = CALL( "GETDRIVE", " " )
      ENDIF
    ENDIF


    lc_return = CALL( "CURDIR", ;
                LEFT( UPPER(pc_drive) , 1 ) + SPACE( 65 ) )

  ENDIF

RETURN( lc_return )
*-- EOF: CurDir( pc_drive )


PROCEDURE Dos
*--------------------------------------------------------------------
* NAME
*   DOS - Present a DOS prompt in a window.
*
* DESCRIPTION
*   DOS allows easy DOS access from the dBASE design surfaces.
*
*   When called, DOS will prompt the user for a DOS
*   command to run.  This can be either a resident DOS
*   command such as "dir", a program name, or a .BAT
*   file.  DOS will then run the DOS command
*   entered, and automatically return to dBASE when
*   finished.  DOT till restore the original screen.
*
* DEPENDENCIES
*    _StrInBox() function in OACC.PRG
*    _TalkMode() function in OACC.PRG
*
* LIMITATIONS
*   Also, be very careful when deleting any files from
*   within dBASE IV.  Some may be files that dBASE IV
*   needs in order to run.
*
* VERSION
*   dBASE IV 1.5
*
*--------------------------------------------------------------------
  PRIVATE ALL LIKE l?_*

  DO Talkoff
  ll_status = SET( "STATUS" ) = "ON"    && Initial STATUS setting

  SAVE SCREEN TO dos

  lc_command = "command.com"
  ln_command = StrInBox( 5, 6, ;
                          "Enter the DOS program to run",;
                          lc_command, ;
                          128, ;
                          30 ;
                       )

  SET STATUS OFF

  IF .NOT. ISBLANK( lc_command ) .AND. ln_command = 0

    ln_result = RUN( lc_command, .T. )

    *-- Have the user press a key to continue
    ll_console = SET( "CONSOLE" ) = "ON"
    SET CONSOLE ON
    SET TALK ON
    WAIT "Press any key to continue . . ."
    SET TALK OFF
    IF .NOT. ll_console
      SET CONSOLE OFF
    ENDIF

  ENDIF

  IF ll_status
    SET STATUS ON
  ENDIF
  RESTORE SCREEN FROM dos
  RELEASE SCREEN dos

  DO Talkon

RETURN 
*-- EOP: Dos


FUNCTION Dot        && Call Dot Prompt in a Window
*-----------------------------------------------------------------------------
*-- Notes......: Call Dot prompt in a window
*-----------------------------------------------------------------------------
   DO Talkoff
   SAVE SCREEN TO w_mc
   DO shadowg WITH 10,0,20,77
   DEFINE WINDOW w_mc from 10,0 TO 20,79 DOUBLE
   ACTIVATE WINDOW w_mc
   @ 8,0 SAY "Type: RESUME to Return"
   SUSPEND
   RELEASE WINDOW w_mc
   RESTORE SCREEN FROM w_mc
   RELEASE SCREEN w_mc
   DO Key_Vars
   KEYBOARD CHR(kn_Enter) + REPLICATE( CHR(kn_BakSpce), 5 )
   DO Rele_Vars
   DO Talkon
RETURN .T.
*-- EOF: Dot()


FUNCTION Ed         && Call Modify Command in a Window 
PARAMETER p_file
*-----------------------------------------------------------------------------
*-- Notes......: Call Modify Command in a window 
*-----------------------------------------------------------------------------
  DO Talkoff
  SAVE SCREEN TO w_mc
  DO shadowg WITH 10,5,20,74
  DEFINE WINDOW w_mc from 10,5 TO 20,74 DOUBLE
  MODIFY COMMAND (p_file) WINDOW w_mc
  RELEASE WINDOW w_mc
  RESTORE SCREEN FROM w_mc
  RELEASE SCREEN w_mc
  DO Key_Vars
  KEYBOARD CHR(kn_Enter) + REPLICATE( CHR(kn_BakSpce), 2 )
  KEYBOARD [("")]
  KEYBOARD CHR( kn_Home ) + REPLICATE( CHR(kn_Del), 4 )
  KEYBOARD CHR( kn_End ) + REPLICATE( CHR(kn_LeftArw), 2 )
  DO Rele_Vars
  DO Talkon
RETURN .T.   
*-- EOF: Ed( p_file )


FUNCTION GetDrive   && Return the current DOS drive
*-----------------------------------------------------------
* Returns the current DOS drive
*
* Synopsis:
*
* GETDRIVE( )
*
* Description:
*
* GETDRIVE() returns the current DOS drive.
*
* Examples:
*
*     ? GETDRIVE()
*     
* Warning: GETDRIVE.BIN must be loaded before the call.  Use
*          the following procedure to load and release the
*          BIN file.
*
*          DO Load_Bin WITH "getdrive"
*          ...  Code to execute GetDrive()
*          DO Rele_Bin WITH "getdrive"
*
*-----------------------------------------------------------
PRIVATE lc_return

  lc_return = ""

  IF glgetdrive   && BIN file correctly LOADed with LOAD_BIN

    lc_return = CALL( "GETDRIVE", " " )

  ENDIF

RETURN( lc_return )
*-- EOF: GetDrive()


FUNCTION Header     && Return Length of DBF Header
********************************************************************************
* PROGRAM: HEADER.PRG
*    DATE: 8/11/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S HEADER() FUNCTION
*
* RETURNS: RETURNS LENGTH OF THE HEADER AREA OF CURRENT DBF
*   (SEE RECSIZE() IN THE dBASE IV LANGUAGE REFERENCE)
*
********************************************************************************
  PRIVATE mfcount

  IF LEN(DBF()) = 0
  RETURN 0
ENDIF

lc_talk = TalkMode( lc_talk )     && Restore previous TALK setting

mfcount = 1
DO WHILE LEN(FIELD(mfcount)) > 0
  mfcount = mfcount + 1
ENDDO

lc_talk = TalkMode(.F.)
RETURN 32 * (mfcount - 1) + 35
*-- EOF: Header()


FUNCTION HtoI       && Convert Hex Byte String to Integer Value
PARAMETERS param1
PRIVATE position, result, value, power16

param1 = UPPER(param1)
position = LEN(param1)
result = 0
power16 = 1

DO WHILE position > 0
   value = SUBSTR(param1, position, 1)
   IF value >= '0' .AND. value <= '9'
      value = VAL(value)
   ELSE
      value = ASC(value) - ASC('A') + 10
   ENDIF
   result = result + value * power16
   position = position - 1
   power16 = power16 * 16
ENDDO

RETURN result
*-- EOF: HtoI( param1 )


FUNCTION IndexOrd   && Determine Order Number of Controlling Index
********************************************************************************
* PROGRAM: INDEXORD.PRG
*    DATE: 8/11/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S INDEXORD()
*
* RETURNS: NUMERIC POSITION OF CONTROLLING INDEX IN LIST OF OPEN INDEX FILES
*
********************************************************************************
  PRIVATE morder, mindex

  * GET NAME OF CONTROLLING INDEX OR TAG
  morder = order()
  IF LEN(morder) = 0
    RETURN 0
  ENDIF


  mindex = 1
*-- TAG RETURNS NAME OF INDEX OR TAG IN POSITION mindex
  DO WHILE tag(mindex) <> morder
    mindex = mindex + 1
  ENDDO

RETURN mindex
*-- EOF: IndexOrd()


FUNCTION IsInView   && Check to see if a field is in current DBF
PARAMETER p_field
*------------------------------------------------------------------------
* Synopsis:
*
* IsInView( <p_field> )
* 
* The ISINVIEW() function will determine if the <p_field> is in the
* current view.
*
* The ISINVIEW() function currently checks only the current open DBF
* file.
*
*------------------------------------------------------------------------
  PRIVATE ln_fldcntr, ll_result

  ll_result = .F.                   && Assume the worst, field not in DBF
  ln_fldcnt = 1                     && Counter for looping fields
  DO WHILE .t.                                                   

    lc_field = FIELD( ln_fldcnt )   && Get the current field name
    IF ISBLANK( lc_field )            && Check for end of field list
      EXIT                          && and bail out w/o setting ll_result
    ELSE
      IF RTRIM(p_field) = lc_field  && Check for match
        ll_result = .T.             && Found it, set the return flag TRUE
        EXIT                        && and bail out of DO WHILE loop
      ELSE
        ln_fldcnt = ln_fldcnt + 1   && Increment field counter
      ENDIF
    ENDIF

  ENDDO

RETURN( ll_result )
*-- EOF: IsInVIew( p_field )


FUNCTION IsTime     && Determine if a String is a Time String
PARAMETER str_time
*-------------------------------------------------------------------------
* Synopsis:
* 
* ISTIME( <expCTIME> )
* 
* The ISTIME() function determines if the <ExpCTIME> expression is a 
* properly formatted dBASE IV time string and return .T. if it is.  The
* character used to delimit hours from minutes from seconds is ignored.
* Whatever the delimiter is, it must be in colunm positions 3 and 6.
* Leading zeros are required for the time string to pass the midnight
* condition.
* 
*-----------------------------------------------------------------------------
PRIVATE lc_result, lc_hour, lc_minute, lc_second

lc_result = .F.                        && Assume bogus time string
lc_hour   = 0 
lc_minute = 0
lc_second = 0

IF TYPE("str_time") = "C" .AND. LEN(str_time) = 8

  lc_hour = VAL( SUBSTR( str_time, 1, 2 ) )
  IF lc_hour >= 0 .AND. lc_hour < 24

    lc_minute = VAL( SUBSTR( str_time, 4, 2 ) )
    IF lc_minute >= 0 .AND. lc_minute < 60

      lc_second = VAL( SUBSTR( str_time, 7, 2 ) )
      IF lc_second >= 0 .AND. lc_minute < 60

        lc_result = .T.

      ENDIF

    ENDIF

  ENDIF

ENDIF

IF lc_hour = 0 .AND. lc_minute = 0 .AND. lc_second = 0 .AND. ;
   SUBSTR( str_time, 1, 2 ) <> "00"
  lc_result = .F.
ENDIF

RETURN ( lc_result )
*-- EOP: istime( str_time )


FUNCTION IsWhite    && Determine if String Fully Contains White Space
PARAMETER chkstr
*-------------------------------------------------------------------------
* Synopsis:
* 
* ISWHITE( <expC1> )
* 
* The ISWHITE() function determines if all of the characters in <expC1> 
* are white space characters, and then returns .T. if they are.  
* White space is defined as a space, tab, carriage return, formfeed, or 
* linefeed characters.  If all of the characters are not white space, or
* an invalid function argement is used, a .F. is returned.
*-------------------------------------------------------------------------
PRIVATE l_chkstr                       && Length of parameter
PRIVATE cur_pos                        && Current position in chkstr
PRIVATE white_sp                       && String of white space characters
PRIVATE rtn_val                        && Return value

*-- Check arguments
IF .NOT. TYPE("chkstr") $ "MC"
  RETURN ( .F. )
ENDIF

white_sp = CHR( 13)                    && Normal carriage return
white_sp = white_sp + CHR(141)         && Memo field carriage return
white_sp = white_sp + CHR( 32)         && Space character
white_sp = white_sp + CHR( 10)         && Line feed
white_sp = white_sp + CHR( 09)         && Horizontal Tab
white_sp = white_sp + CHR( 12)         && Form Feed

*-- Get the length of chkstr to avoid computing it all of the time
l_chkstr = LEN(chkstr)

rtn_val = .T.                          && Assume innocent until proven guilty
cur_pos = 1
DO WHILE cur_pos <= l_chkstr
  IF .NOT. SUBSTR( chkstr, cur_pos, 1 ) $ white_sp
    rtn_val = .F.                      && Character was not white space
    EXIT                               && Bail out of DO WHILE
  ENDIF
  cur_pos = cur_pos + 1
ENDDO

RETURN ( rtn_val )
*-- EOP: IsWhite( chkstr )


FUNCTION ItoH       && Convert Integer Value to Hex Byte
PARAMETERS param1, param2
********************************************************************************
* PROGRAM: ITOH.PRG
*    DATE: 8/31/88
*      BY: DON KELLER
* PURPOSE: USER DEFINED FUNCTION TO REPLACE QUICKSILVER'S ITOH() FUNCTION
*
*  PARAM1: NUMERIC EXPRESSION TO CONVERT
*  PARAM2: IF <> 0, PAD RETURNED STRING WITH LEADING ZEROS TO THIS LENGTH
* RETURNS: A CHARACTER STRING WHICH IS THE HEXADECIMAL REPRESENTATION OF PARAM1
*
********************************************************************************
PRIVATE temp, result, power16

result = ""
power16 = 1
DO WHILE power16 < param1
   power16 = power16 * 16
ENDDO
IF power16 > param1
   power16 = power16 / 16
ENDIF
DO WHILE power16 >= 1
   IF power16 > param1
      result = result + "0"
   ELSE
      temp = INT(param1 / power16)
      IF temp < 10
         result = result + STR(temp,1)
      ELSE
         result = result + CHR(temp - 10 + ASC('A'))
      ENDIF
      param1 = param1 - power16 * temp
   ENDIF
   power16 = power16 / 16
ENDDO      

IF param2 > 0 .AND. LEN(result) < param2
   result = REPLICATE('0', param2 - LEN(result)) + result
ENDIF

RETURN result
*-- EOF: ItoH(param1, param2)


FUNCTION OverFlow   && Determine if a Value is a Numeric Overflow
PARAMETER num_value
*-----------------------------------------------------------------------------
* Synopsis:
* 
* OVERFLOW( <expN> )
* 
* The OVERFLOW() function determines if the <expN> expression is a numeric 
* overflow.  If the value is a numeric overflow or not a numeric value
* OVERFLOW() will return .T.  If the <expN> is a real numeric value OVERFLOW()
* will return .F.
* 
*-----------------------------------------------------------------------------
PRIVATE lc_result

IF .NOT. TYPE("num_value") $ "NF"
  lc_result = .T.
ELSE
  IF num_value < .9E308
    lc_result = .F.
  ELSE
    lc_result = .T.
  ENDIF
ENDIF

RETURN (lc_result)
*-- EOP: OverFlow( num_value )


FUNCTION Proper     && Convert a String to Proper Name Format
PARAMETERS param1
********************************************************************************
* PROGRAM: PROPER.PRG
*    DATE: 8/31/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE QUICKSILVER'S PROPER() FUNCTION
*
*  PARAM1: CHARACTER STRING TO CONVERT
* RETURNS: PARAM1 WITH THE FIRST LETTER OF EACH WORD CAPITALIZED
*
********************************************************************************
  PRIVATE position

  param1 = LOWER(param1)
  position = 2

  IF SUBSTR(param1,1,1) <> ' '
    param1 = STUFF(param1,1,1,UPPER(SUBSTR(param1,1,1)))
  ENDIF

  DO WHILE position <= LEN(param1)
    IF SUBSTR(param1,position-1,1) = ' '
      param1 = STUFF(param1,position,1,UPPER(SUBSTR(param1,position,1)))
    ENDIF
    position = position + 1
  ENDDO

RETURN param1
*-- EOF: Proper( param1 )


FUNCTION RAt        && AT() Starting from the Rigth Side
PARAMETERS msubstr, mstring
********************************************************************************
* PROGRAM: RAT.PRG
*    DATE: 8/11/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S RAT() FUNCTION
*
*  PARAM1: CHARACTER STRING EXPRESSION TO LOCATE
*  PARAM2: CHARACTER STRING EXPRESSION TO SEARCH
* RETURNS: STARTING POSITION OF LAST INSTANCE OF PARAM1 WITHIN PARAM2
*
********************************************************************************
PRIVATE mpos, mlen, lc_result, lc_talk

mlen = LEN(msubstr)
lc_result = LEN(mstring) - mlen

IF lc_result < 1
  lc_result = 0
ELSE
  DO WHILE lc_result > 0
    IF msubstr = SUBSTR(mstring, lc_result, mlen)
      EXIT
    ENDIF
    lc_result = lc_result - 1
  ENDDO
ENDIF

RETURN (lc_result)
*--EOF: RAt( msubstr, mstring )


FUNCTION Sec2Time   && Convert Seconds Past Midnight to Time String
PARAMETERS seconds
*-----------------------------------------------------------------------------
* Synopsis:
* 
* SEC2TIME( <expN> )
*                                
* The SEC2TIME() function converts an interger value <expN> representing
* the number of seconds from midnight to a time formatted string.  Values
* greater than 86400 seconds (the number of seconds on one day) will only
* show up as one day of time.  In invalid agrument type will return a NULL
* string.
* 
* See Also:  TIMEDIFF(), TIME2SEC()
* 
*-----------------------------------------------------------------------------
PRIVATE lc_lc_result, hrs, min, secs

*-- Check for valid type
  IF .NOT. TYPE( "seconds" ) $ "FIN"
    lc_result = ""
  ELSE

*-- Convert the seconds amount to seconds within one day if required
    IF seconds > 86400
      seconds = MOD( 86400, seconds )
    ENDIF

*-- Form the time formatted string
    hrs = LTRIM( STR( INT( seconds / 3600), 2) )
    IF LEN(hrs) = 1
      lc_result = "0" + hrs
    ELSE
      lc_result = hrs
    ENDIF

    min = LTRIM( STR( INT( (seconds - VAL(hrs)*3600)/60 ), 2) )
    IF LEN(min) = 1
      lc_result = lc_result + ":" + "0" + min
    ELSE
      lc_result = lc_result + ":" + min
    ENDIF

    secs = LTRIM( STR( (seconds - VAL(hrs)*3600 - VAL(min)*60), 2) )
    IF LEN(secs) = 1
      lc_result = lc_result + ":" + "0" + secs
    ELSE
      lc_result = lc_result + ":" + secs
    ENDIF

  ENDIF && End check for valid type


RETURN( lc_result )
*-- EOF: Sec2Time( seconds )


FUNCTION Selected   && Return WorkArea of Selected DBF
*-----------------------------------------------------------
* PROGRAM: SELECTED.PRG
*    DATE: 8/20/88
*      BY: Don Keller, StepIVward 1.0 
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S
*          SELECT() FUNCTION
*
* RETURNS: CURRENT SELECT AREA NUMBER
*
*-----------------------------------------------------------
  PRIVATE mtemp,mcnt

  mtemp = DBF()
  IF LEN(TRIM(mtemp)) = 0
    RETURN select()
  ENDIF

  mcnt = 1
  DO WHILE mcnt <= 10                    && Process all ten workareas
  IF DBF(mcnt) = mtemp .AND. LEN(DBF(mcnt)) = LEN(mtemp)
    RETURN mcnt
  ENDIF
  mcnt = mcnt + 1
ENDDO
*-- EOF: Selected()


FUNCTION SetEsc     && Replace Clipper SetEsc() Function
PARAMETERS param
*-----------------------------------------------------------
* PROGRAM: SETESC.PRG
*    DATE: 8/20/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S
*          SETCANCEL() FUNCTION
*
*   PARAM: NEW VALUE FOR SET ESCAPE (.T. => ON; .F. => OFF)
* RETURNS: CURRENT SET ESCAPE SETTING (.T. => ON; .F. =>
*          OFF)
*
*-----------------------------------------------------------

  IF TYPE('param') = 'L'
    IF param
      SET ESCAPE ON
    ELSE
      SET ESCAPE OFF
    ENDIF
  ENDIF

  IF set('ESCAPE') = 'ON'
  RETURN .T.
ELSE
  RETURN .F.
ENDIF
*-- EOF: SetEsc( param )


FUNCTION SetPrc     && Replace Clipper SETPRC() Function
PARAMETERS row, col
*-----------------------------------------------------------
* PROGRAM: SETPRC.PRG
*    DATE: 8/20/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S
*          SETPRC() FUNCTION
*          SETS INTERNAL ROW AND COLUMN FOR THE PRINTER
*
*  PARAM1: NEW INTERNAL ROW POSITION
*  PARAM1: NEW INTERNAL COLUMN POSITION
* RETURNS: .F.
*
*-----------------------------------------------------------
  _plineno = row
  _pcolno = col
RETURN .F.
*-- EOF: SetPrc( row, col )


FUNCTION ShowNdx    && Display Progess of INDEX
*-----------------------------------------------------------
* Display a BAR graph of the index in progess
*-----------------------------------------------------------
  trecs = RECCOUNT()
  @ 23,00 TO 23,79
  @ 23,00 TO 23,((RECNO()*80)/trecs)-1 DOUBLE
RETURN .T.
*-- EOF: ShowNdx()


FUNCTION SInkey     && Replace Quicksilver SINKEY() Function
*-----------------------------------------------------------
* PROGRAM: SINKEY.PRG
*    DATE: 8/31/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE QUICKSILVER'S 
*          SINKEY() FUNCTION
*
* RETURNS: ONE-BYTE STRING OF CHAR TYPED OR TWO-BYTE STRING 
*          FOR SPECIAL KEYS
*
*-----------------------------------------------------------
  PRIVATE value, qwerty, position

  value = INKEY()

  DO CASE

    CASE value >= 0 .AND. value <= 255 .AND. value <> 28
    RETURN CHR(value)

  CASE value = 28
    * F1
    RETURN CHR(255) + CHR(59)

  CASE value <= -1 .AND. value >= -9
    * F2 thru F10
    RETURN CHR(255) + CHR(59-value)

  CASE value <= -10 .AND. value >= -19
    * CTRL F1 thru CTRL F10
    RETURN CHR(255) + CHR(84-value)

  CASE value <= -20 .AND. value >= -28
    * SHIFT F1 thru SHIFT F9
    RETURN CHR(255) + CHR(64-value)


  CASE value >= -451 .AND. value <= -443
    * ALT 1 thru ALT 9
    RETURN CHR(255) + CHR(120+451+value)

  CASE value = -452
    * ALT 0
    RETURN CHR(255) + CHR(129)

  CASE value >= -435 .AND. value <= -410
    * ALT A thru ALT Z
    qwerty = "QWERTYUIOP    ASDFGHJKL     ZXCVBNM"
    position = AT(CHR(435+ASC('A')+value), qwerty)
    RETURN CHR(255) + CHR(position+15)

ENDCASE

RETURN ""
*-- EOF: SInkey()


FUNCTION StrSubst   && Replace a char with another throughout a string
PARAMETERS p_target, p_lookfor, p_repwith
*-----------------------------------------------------------
* Replaces a character with another throughout a string
*
* Synopsis:
*
* STRSUBST( <expC1>, <expC2>, <expC3> )
*
* Description:
*
* STRSUBST() replaces all occurances of the first character
* in <expC2> with the first character in <expC3> for string 
* <expC1>.  STRSUBST() will return a null string if all of
* the parameters are not string values.
*
* Examples:
*
*   ? STRSUBST( "This is a string", "i", "a" )
*     Thas as a strang
*
* See also: StrTran
*
* Author: Bill Ramos
*
* Warning: STRSUBST.BIN must be loaded before the call.  Use
*          the following procedure to load and release the
*          BIN file.
*
*          DO Load_Bin WITH "strsubst"
*          ...  Code to execute StrSubst()
*          DO Rele_Bin WITH "strsubst"
*
*-----------------------------------------------------------
PRIVATE lc_return

  lc_return = ""

  IF TYPE( "p_target" )  = "C" .AND. ;
     TYPE( "p_lookfor" ) = "C" .AND. ;
     TYPE( "p_repwith" ) = "C"

    IF glstrsubst && BIN file correctly LOADed with LOAD_BIN
      lc_return = CALL( "STRSUBST", ( p_target ), ;
                        p_lookfor, p_repwith )
    ENDIF
  ENDIF

RETURN( lc_return )
*-- EOF: StrSubst( p_target, p_lookfor, p_repwith )


FUNCTION StrTran    && Replace Clipper STRTRAN() Function
PARAMETERS ssearch, slocate, sreplace, repl_start, repl_max
*-----------------------------------------------------------
* PROGRAM: STRTRAN.PRG
*    DATE: 8/22/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S 
*          STRTRAN() FUNCTION
*
*  PARAM1: CHARACTER STRING TO SEARCH
*  PARAM2: CHARACTER STRING TO LOCATE
*  PARAM3: REPLACEMENT STRING
*  PARAM4: NUMBER OF FIRST OCCURRENCE TO REPLACE
*  PARAM5: NUMBER OF OCCURRENCES TO REPLACE
*
* RETURNS: THE UPDATED CHARACTER STRING
*
*-----------------------------------------------------------
  PRIVATE done, temp, incr, fnd_count, repl_count

  fnd_count = 0
  repl_count = 0
  temp = 1
  done = .F.
  DO WHILE .NOT. done
    temp = temp - 1 + AT(slocate, SUBSTR(ssearch,temp))
    IF temp = 0
      done = .T.
    ELSE
      fnd_count = fnd_count + 1
      IF fnd_count >= repl_start
        IF repl_max = -1 .OR. repl_count < repl_max
          repl_count = repl_count + 1
          ssearch = STUFF(ssearch, temp, LEN(slocate), sreplace)
          incr = LEN(sreplace)
        ELSE
          done = .T.
        ENDIF
      ELSE
        incr = LEN(slocate)
      ENDIF
      temp = temp + incr
      IF temp > LEN(ssearch) - LEN(slocate) + 1
        done = .T.
      ENDIF
    ENDIF
  ENDDO

RETURN ssearch
*-- EOF: StrTran(  ssearch, slocate, sreplace, repl_start, repl_max )


FUNCTION TalkMode   && Set and Query TALK Setting
PARAMETER howtoset
*-----------------------------------------------------------------------------
* 
* Synopsis:	
* 
* TALKMODE( <expL>/<anyother exp> )
* 
* This function sets the talk on/off mode based on <expL>.  The function 
* returns a logical value based on the setting of the set talk on/off 
* mode prior to execution of the function.  Using a non logical value
* for <expL> will return the current state of set talk on/off.
* 
* Examples:
* 
* Here is an example where TALKMODE() is used to set the talk mode on 
* and then restore the original talk mode setting:
* 
* oldmode = TALKMODE(.T.)      && Set talk mode on
* 
*         = TALKMODE(oldmode)  && Return mode to original setting
* 
* Here is an example which toggles the insert mode to the opposite value:
* 
*         = TALKMODE( .NOT. TALKMODE(0))
* 
*-----------------------------------------------------------------------------
PRIVATE lc_old

  IF SET("TALK") = "ON"
    SET TALK OFF
    lc_old = "ON"
  ELSE
    lc_old = "OFF"
  ENDIF

  IF TYPE( "howtoset" ) = "L"
    IF howtoset
      SET TALK ON
    ELSE
      SET TALK OFF
    ENDIF
  ENDIF

RETURN( lc_old )
*-- END: TalkMode( howtoset )


FUNCTION Time2Sec   && Convert a Time String to Seconds
PARAMETERS time_str
*-----------------------------------------------------------------------------
* Synopsis:
* 
* TIME2SEC( <expC> )
* 
* The TIME2SEC() function takes a properly formatted time string <expC> and
* returns an integer that represents the number of seconds after midnight.
* If the passed argument is a not the correct type, or not formatted 
* correctly, TIME2SEC will return a -1.
* 
* See Also:  TIMEDIFF(), SEC2TIME(), ISTIME()
* 
*-----------------------------------------------------------------------------
PRIVATE result

*-- Validate the time string values          
  IF IsTime( time_str )
    lc_result = (VAL( SUBSTR( time_str, 1, 2 ) ) * 3600) + ;
                (VAL( SUBSTR( time_str, 4, 2 ) ) * 60  ) + ;
                (VAL( SUBSTR( time_str, 7, 2 ) )       )
  ELSE
    lc_result = 1/0                  && Force numeric overflow
  ENDIF

RETURN( lc_result )
*-- EOF: Time2Sec( time_str )


FUNCTION TimeDiff   && Compute Difference of Two Time Strings
PARAMETERS start_time, end_time
*-----------------------------------------------------------------------------
* Synopsis:
* 
* TIMEDIFF( <expC1>, <expC2> )
* 
* The TIMEDIFF() function substracts time string <expC1> from time string
* <expC2> and returns a time formated string.  If an invalid type argument 
* is passed, then a NULL string is returned.  The time strings are based on
* the 24 hour clock.  If the time strings are not properly formed, then
* a NULL string is returned.
* 
* See Also: TIME2SEC(), SEC2TIME()
* 
*-----------------------------------------------------------------------------
PRIVATE s_hr, s_mn, s_sc, e_hr, e_mn, e_sc, r_hr, r_mn, r_sc
PRIVATE temp, lc_result                       

*-- Check for proper type of arguments
  IF TYPE( "start_time" ) <> "C" .OR. TYPE( "end_time" ) <> "C"
    lc_result = ""
  ELSE

*-- Convert time strings to integer components
    s_hr = VAL( SUBSTR(start_time,1,2) )
    s_mn = VAL( SUBSTR(start_time,4,2) )
    s_sc = VAL( SUBSTR(start_time,7,2) )

    e_hr = VAL( SUBSTR(end_time,1,2) )
    e_mn = VAL( SUBSTR(end_time,4,2) )
    e_sc = VAL( SUBSTR(end_time,7,2) )

*-- Validate the time string values
    IF .NOT. IsTime( start_time ) .OR. .NOT. IsTime( end_time )
      lc_result = ""
    ELSE
  
  
*-- Check to see if the timing spanned midnight
      r_hr = e_hr - s_hr
      IF r_hr < 0
        r_hr = r_hr + 24
      ENDIF

      r_mn = e_mn - s_mn
      IF r_mn < 0
        r_mn = r_mn + 60
        r_hr = r_hr - 1
      ENDIF

      r_sc = e_sc - s_sc
      IF r_sc < 0
        r_sc = r_sc + 60
        r_mn = r_mn -1
      ENDIF
      IF r_mn < 0
        r_mn = r_mn + 60
        r_hr = r_hr - 1
      ENDIF

      temp = LTRIM( STR(r_hr,2) )
      IF LEN( temp ) = 1
        lc_result = "0" + temp
      ELSE
        lc_result = temp
      ENDIF

      temp = LTRIM( STR(r_mn,2) )
      IF LEN( temp ) = 1
        lc_result = lc_result + ":" + "0" + temp
      ELSE
        lc_result = lc_result + ":" + temp
      ENDIF

      temp = LTRIM( STR(r_sc,2) )
      IF LEN( temp ) = 1
        lc_result = lc_result + ":" + "0" + temp
      ELSE
        lc_result = lc_result + ":" + temp
      ENDIF                                   

    ENDIF && End check fo valid time string
  ENDIF && End check for proper character type

RETURN( lc_result )
*-- EOF: TimeDiff( start_time, end_time )


FUNCTION TmpName    && Return an 8 character file root name
*----------------------------------------------------------
* Simulate FoxBASE's SYS(2) call for a temporary file
* name
* 
* Synopsis:
* 
* TMPNAME( )
* 
* Description:
* 
* Returns an 8 character string suitable as a temporary 
* file name.  The is based on the current system time.
* 
* Example:
* 

*   lc_tmpfile = TMPNAME() + ".tmp"
*   USE master
*   COPY TO (lc_tmpfile)
* 
* Warning: TMPNAME.BIN must be loaded before the call.  Use
*          the following procedure to load and release the
*          BIN file.
*
*          DO Load_Bin WITH "tmpname"
*          ...  Code to execute TmpName()
*          DO Rele_Bin WITH "tmpname"
*
*-----------------------------------------------------------
PRIVATE lc_return

  lc_return = ""

  IF gltmpname    && BIN file correctly LOADed with LOAD_BIN
    lc_return = CALL( "TMPNAME", SPACE( 8 ) )
  ENDIF

RETURN( lc_return )
*-- EOF: TmpName( )


FUNCTION Tone       && Replace Clipper TONE() Function
PARAMETERS mfreq, mduration
********************************************************************************
* PROGRAM: TONE.PRG
*    DATE: 8/11/88
*      BY: Don Keller, StepIVward 1.0
* PURPOSE: USER DEFINED FUNCTION TO REPLACE CLIPPER'S TONE() FUNCTION
*
*  PARAM1: FREQUENCY IN CYCLES PER SECOND FOR TONE
*  PARAM2: DURATION IN INCREMENTS OF 1/18 OF A SECOND
* RETURNS: .F.
*
********************************************************************************
  PRIVATE mbell, mconsole, mprinter

  mbell = set('BELL')
  mconsole = set('CONSOLE')
  mprinter = set('PRINTER')

  SET printer OFF
  SET CONSOLE ON
  SET BELL ON

  SET BELL TO mfreq, mduration
  ?? CHR(7)
  SET BELL TO

  IF mconsole = 'OFF'
    SET CONSOLE OFF
  ENDIF

  IF mbell <> 'ON'
    SET BELL OFF
  ENDIF

  IF mprinter = 'ON'
    SET printer ON
  ENDIF

RETURN .F.
*-- EOF: Tone( mfreq, mduration )


FUNCTION Updated    && Determine if User Updated GET Values After READ
*-------------------------------------------------------------
*-- Has data been updated
*-------------------------------------------------------------
  PRIVATE ll_return

  IF READKEY() > 256
    ll_return = .T.
  ELSE
    ll_return = .F.
  ENDIF

RETURN( ll_return )
*-- EOF: Updated()


FUNCTION WhatPara   && Comma Delimited String to Array
PARAMETER num_array, look4str
*-----------------------------------------------------------------------------
* Synopsis:
*
* WHATPARA <expA>, <expC>
*
* The WHATPARA function will create an array <expA> with the character values
* in the comma delimited string <expC>.  The WHATPARA functions main
* intent is a workaround for the seven parameter limit for UDF's.
* WHATPARA will return the number of array elements assigned.  WHATPARA
* will over write the existing array definition if it already exists.
*
* Examples:
*
*   howmany = WHATPARA(paralist,"1,2,foo bar,4")
*
*   The array PARALIST[1] = "1"
*             PARALIST[2] = "2"
*             PARALIST[3] = "foo bar"
*             PARALIST[4] = "4"
*   howmany = 4
*
* Restrictions:
*
*   Can only be used with dBASE > 1.1
*
*-----------------------------------------------------------------------------
   PRIVATE lc_delimit, lc_posit, lc_lenlook, lc_cnt, lc_args,;
           lc_str, lc_nxt_tok

   *-- Check for type of look4for string, terminate if not character
   IF TYPE("look4str") <> "C" .OR. TYPE("num_array") <> "C"
   RETURN(.F.)
ENDIF

*-- Check for the existance of the array
IF TYPE("&num_array[1]") <> "U"
   RELEASE &num_array
ENDIF

*-- Determine number of arguments, and assign it to LC_ARGS
lc_delimit = ","
lc_posit = 1
lc_lenlook = LEN(look4str)
lc_cnt = 0
DO WHILE lc_posit < lc_lenlook
   IF SUBSTR(look4str, lc_posit, 1) = lc_delimit
      lc_cnt = lc_cnt + 1
   ENDIF
   lc_posit = lc_posit + 1
ENDDO
lc_args = lc_cnt + 1

*-- Declare the return array NUM_ARRAY
PUBLIC ARRAY &num_array[lc_args]

*-- Put the elements in place
lc_posit = 1
lc_str = look4str
lc_nxt_tok = AT(lc_delimit,lc_str)
DO WHILE lc_nxt_tok > 0
   STORE LEFT(lc_str, lc_nxt_tok-1) TO &num_array[lc_posit]
   lc_str = SUBSTR(lc_str, lc_nxt_tok + 1 )
   lc_nxt_tok = AT(lc_delimit,lc_str)
   lc_posit = lc_posit + 1
ENDDO
STORE LEFT(lc_str, LEN(lc_str)) TO &num_array[lc_posit]

RETURN (lc_args)
*-- EOF: WhatPara( num_array, look4str )


PROCEDURE Key_Vars  && Set INKEY() and READKEY() Values to Variables
*----------------------------------------------------------------------------
* Enumerate the key values for LASTKEY() and INKEY() functions
*
* To check for the Escape key after the INKEY()
* 
*   ln_key = INKEY(0)   && Wait for any key press
*   IF ln_key = kn_Esc  && Escape was pressed
*     DO esc_hand
*   ENDIF
*
*----------------------------------------------------------------------------
IF TYPE("kn_Esc") = "U"

  PUBLIC kn_End     , kn_Tab     , kn_Enter   , kn_CtrlEnd , kn_CtrlY   , ;
       kn_Home    , kn_Esc     , kn_CtrlHme , kn_CtrlPDn , kn_CtrlPUp , ;
       kn_Space   , kn_BakSpce , kn_RghtArw , kn_UpArw   , kn_LeftArw , ;
       kn_DownArw , kn_PgDn    , kn_PgUp    , kn_F1      , kn_Del     , ;
       kn_CtrLArw , kn_CtrRArw , kn_f7      , kn_ShftF7

  kn_End     =   2      && Ctrl-B
  kn_Tab     =   9      && Ctrl-I
  kn_Enter   =  13      && Ctrl-M
  kn_CtrlEnd =  23      && Ctrl-W
  kn_CtrlY   =  25
  kn_Home    =  26      && Ctrl-Z
  kn_Esc     =  27      && Ctrl-[
  kn_CtrlHme =  29      && Ctrl-]
  kn_CtrlPDn =  30      && Ctrl-PgDn
  kn_CtrlPUp =  31      && Ctrl-PgUp
  kn_Space   =  32
  kn_BakSpce = 127
  kn_RghtArw =   4      && Ctrl-D
  kn_UpArw   =   5      && Ctrl-E
  kn_LeftArw =  19      && Ctrl-S
  kn_DownArw =  24      && Ctrl-X
  kn_PgDn    =   3      && Ctrl-C
  kn_PgUp    =  18      && Ctrl-R
  kn_F1      =  28      && Ctrl-\
  kn_Del     =   7      && Ctrl-G
  kn_CtrLArw =   1      && Ctrl-A
  kn_CtrRArw =   6      && Ctrl-F
  kn_F7      =  -6
  kn_ShftF7   = -26

*----------------------------------------------------------------------------
* Enumerate the key values for READKEY()
*
* To check to see if data has changed
*
*   IF READKEY() >= rn_updated   && Data has changed
*     REPLACE name WITH m->name
*   ENDIF
*
* To check for page down regardless of data change
*
*   ln_readkey = READKEY()
*   IF ln_readkey = rn_PgDn .OR. ln_readkey = rn_PgDn+rn_Updated
*     DO pgdn_hand
*   ENDIF
*
*----------------------------------------------------------------------------
  PUBLIC rn_Updated , rn_LeftArw , rn_BakSpce , rn_RghtArw , rn_CtrLArw , ;
       rn_CtrRArw , rn_UpArw   , rn_DownArw , rn_PgUp    , rn_PgDn    , ;
       rn_Esc     , rn_CtrlEnd , rn_Enter   , rn_EnterA  , rn_CtrlHme , ;
       rn_CtrlPUp , rn_CtrlPDn , rn_F1

  rn_Updated = 256      && Add to rn_key value for updated condition
  rn_LeftArw =   0      && Includes Ctrl-S and Ctrl-H - backward one character
  rn_BakSpce =   0      && backward one character                                   
  rn_RghtArw =   1      && Includes Ctrl-D and Ctrl-L - forward one character
  rn_CtrLArw =   2      && Ctrl-Left Arrow, includes Ctrl-A - previous word
  rn_CtrRArw =   3      && Ctrl-Right Arrow, includes Ctrl-F - next word
  rn_UpArw   =   4      && Includes Ctrl-E and Ctrl-K - backward one field
  rn_DownArw =   5      && Includes Ctrl-J and Ctrl-X - forward one field
  rn_PgUp    =   6      && Includes Ctrl-R - backward one screen
  rn_PgDn    =   7      && Includes Ctrl-C - forward one screen
  rn_Esc     =  12      && Includes Ctrl-Q - Terminate w/o save
  rn_CtrlEnd =  14 + rn_updated  && Includes Ctrl-W - Terminate w/save
  rn_Enter   =  15      && Includes Ctrl-M  RETURN of fill last record
  rn_EnterA  =  16      && Enter at the beginning of a record in APPEND
  rn_CtrlHme =  33      && Ctrl-Home - Menu display toggle
  rn_CtrlPUp =  34      && Ctrl-PgUp - Zoom Out
  rn_CtrlPDn =  35      && Ctrl-PgDn - Zoom In
  rn_F1      =  36      && Help function key
ENDIF && TYPE("kn_Esc") = "U"

RETURN
*-- EOP: Key_Vars.prg


PROCEDURE Load_Bin  && Load a BIN File and Set the Load Status
PARAMETER binfile
*-----------------------------------------------------------------------------
* Synopsis:
* 
* DO LOAD_BIN WITH <expF>
* 
* LOAD_BIN loads a BIN file is the file exists and creates a global variable
* that is made up of the prefix "GL" and a suffix the same as the BIN file's
* root name.  The global variable is set to true (.T.) is properly loaded, or
* it's set to false (.F.) is the BIN file was not loaded.  A full file path 
* can be specified for the BIN file.
* 
* If the BIN file is already loaded, noted by the global variable set to
* true, then the global variable will return true with no further action.
* 
* Example:
* 
*   DO Load_Bin WITH "scroll"
* 
* This will load the BIN file SCROLL into memory.  The global variable
* named GLSCROLL will be created and set to true (.T.)
* 
* See Also:  RELE_BIN
* 
*-----------------------------------------------------------------------------
PRIVATE lc_found, lc_dot, lc_back, lc_name

*-- Make sure bin file exists
IF "." $ binfile
  IF FILE( binfile )
    lc_found = .T.
  ELSE
    lc_found = .F.
  ENDIF
ELSE
  IF FILE( binfile + ".BIN" )
    lc_found = .T.
  ELSE
    lc_found = .F.
  ENDIF
ENDIF

*-- Make PUBLIC variable to denote BIN file is loaded
lc_back = RAT("\", binfile)
IF "." $ binfile                                   
  lc_dot  =  AT(".", binfile)
  lc_name = SUBSTR(binfile, lc_back+1, lc_dot-lc_back+1)
ELSE
  lc_name = SUBSTR(binfile, lc_back+1, LEN(binfile)-lc_back)
ENDIF

IF TYPE( "GL" + lc_name ) = "U"
  PUBLIC gl&lc_name
  gl&lc_name = .F.
ENDIF

IF .NOT. gl&lc_name .AND. lc_found
  LOAD &binfile
  gl&lc_name = .T.
ENDIF

RETURN
*-- EOP: Load_Bin WITH binfile


PROCEDURE LoadBins  && Load StepIVWard BIN modules
*-----------------------------------------------------------
* Load StepIVWard BIN modules
*-----------------------------------------------------------
DO load_bin WITH "CREATE"
DO load_bin WITH "CURDIR"
DO load_bin WITH "GETDRIVE"
DO load_bin WITH "STRSUBST"
DO load_bin WITH "TMPNAME"
RETURN   
*-- EOP: LoadBins


PROCEDURE Rele_Bin  && Release a BIN File and Clear Load Status
PARAMETER binfile
*-----------------------------------------------------------------------------
* Synopsis:
* 
* DO RELE_BIN WITH <expF>
* 
* RELE_BIN will release a BIN file from memory, based on the global variable
* set by LOAD_BIN.  When released, the global variable will be set to false.
* A full file path may be used, but only the root file name is required to
* release a BIN file from memory.
* 
* Example:
* 
*   DO RELE_BIN WITH "scroll"
* 
* This will release the BIN file named scroll, and set the global variable,
* GLSCROLL to false (.F.).
* 
* See Also:  LOAD_BIN
* 
*-----------------------------------------------------------------------------
PRIVATE lc_dot, lc_back, lc_name

*-- Make PUBLIC variable to denote BIN file is loaded
lc_back = RAT("\", binfile)
IF "." $ binfile                                   
  lc_dot  =  AT(".", binfile)
  lc_name = SUBSTR(binfile, lc_back+1, lc_dot-lc_back+1)
ELSE
  lc_name = SUBSTR(binfile, lc_back+1, LEN(binfile)-lc_back)
ENDIF

IF TYPE( "GL" + lc_name ) = "U"
  PUBLIC gl&lc_name
  gl&lc_name = .F.
ENDIF

IF gl&lc_name
  RELEASE MODULE &lc_name
  gl&lc_name = .F.
ENDIF

RETURN
*-- EOP: Rele_Bin WITH binfile


PROCEDURE Rele_Vars && Release the INKEY()/READKEY() var definitions
*-------------------------------------------------------------------
* Releases the variables defined to make code readable in KEY_VARS
*-------------------------------------------------------------------
RELEAS kn_End     , kn_Tab     , kn_Enter   , kn_CtrlEnd , kn_CtrlY   , ;
       kn_Home    , kn_Esc     , kn_CtrlHme , kn_CtrlPDn , kn_CtrlPUp , ;
       kn_Space   , kn_BakSpce , kn_RghtArw , kn_UpArw   , kn_LeftArw , ;
       kn_DownArw , kn_PgDn    , kn_PgUp    , kn_F1      , kn_Del     , ;
       kn_CtrLArw , kn_CtrRArw , kn_f7      , kn_ShftF7

RELEAS rn_Updated , rn_LeftArw , rn_BakSpce , rn_RghtArw , rn_CtrLArw , ;
       rn_CtrRArw , rn_UpArw   , rn_DownArw , rn_PgUp    , rn_PgDn    , ;
       rn_Esc     , rn_CtrlEnd , rn_Enter   , rn_EnterA  , rn_CtrlHme , ;
       rn_CtrlPUp , rn_CtrlPDn , rn_F1
RETURN
*-- EOP: Rele_Vars


PROCEDURE ReleBins  && Release StepIVWard BIN modules
*-----------------------------------------------------------
* Release StepIVWard BIN modules
*-----------------------------------------------------------
DO rele_bin WITH "CREATE"
DO rele_bin WITH "CURDIR"
DO rele_bin WITH "GETDRIVE"
DO rele_bin WITH "STRSUBST"
DO rele_bin WITH "TMPNAME"
RETURN
*-- EOP: ReleBins


PROCEDURE Shadow    && Display Shadow Effect
PARAMETER x1,y1,x2,y2,dfill
*-------------------------------------------------------------

  IF dfill                              && use fill command not window

    @ x1+1,y1+2 FILL TO x2+1,y2+2 COLOR n+/n

  ELSE                                  && define shadow window

    DEFINE WINDOW shadow_win FROM x1+1,y1+2 TO x2+1,y2+2 none color n+/n
    ACTIVATE WINDOW shadow_win

  ENDIF

RETURN
*-- EOP: Shadow


PROCEDURE ShadowG   && Display Shadow Effect That Grows
PARAMETER x1,y1,x2,y2
*-------------------------------------------------------------
  x0 = x2+1
  y0 = y2+2
  dx = 1
  dy = (y2-y1) / (x2-x1)
  DO WHILE x0 <> x1 .OR. y0 <> y1+2

    @ x0,y0 FILL TO x2+1,y2+2 COLOR n+/n
    x0 = IIF(x0<>x1,x0 - dx,x0)
    y0 = IIF(y0<>y1+2,y0 - dy,y0)
    y0 = IIF(y0<y1+2,y1+2,y0)
  ENDDO

RETURN
*-- EOP: ShadowG


PROCEDURE TalkOn    && Set TALK ON if Originally ON
  IF TYPE( "zz_talk" ) = "U"
    SET TALK ON
  ELSE
    IF zz_talk = "ON"
      SET TALK ON
    ENDIF
    RELEASE zz_talk
  ENDIF
RETURN
*-- EOP: TalkOn


PROCEDURE TalkOff   && Set TALK OFF and Save Previous State
  PUBLIC zz_talk
  IF set("TALK") = "ON"
    SET TALK OFF
    zz_talk = "ON"
  ELSE
    zz_talk = "OFF"
  ENDIF
RETURN
*-- EOP: TalkOFF

*-----------------------------------------------------------------------*
*                   UDS - USER DEFINED SURFACES FOLLOW                --*
*-----------------------------------------------------------------------*



PROCEDURE Err_Box
PARAMETERS pc_msg, pl_shadow
*----------------------------------------------------------------------------
* NAME
*   Err_Box - Display an error box
*
* SYNOPSIS
*   DO Err_Box WITH <pc_msg>
*
* DESCRIPTION
*   Err_Box will display the <pc_msg> string in a box and prompt the
*   user to press any key to continue processing.  Err_Box will display
*   the message based on the length of <pc_msg>.
*
* PARAMETERS
*   pc_msg    = the error message to display in the box.  If the length is
*               greater than 76, the trailing part is chopped off.
*   pl_shadow = .t. for shadow effect, or .f. for normal
*
* EXAMPLE
*   DO Err_Box WITH "Incorrect window size"
*   Displays the message in a window as follows at row 9 on the screen:
*                      +------------------------------+
*                      |                              |
*                      |    Incorrect window size     |
*                      |                              |
*                      | Press any key to continue... |
*                      |                              |
*                      +------------------------------+
*   Note that the width of the window will increase to accommodate a longer
*   message string.
*
* LIMITATIONS
*   Truncates the message after 76 characters.  Assumes an 80 character
*   wide screen.  Looks best with SET CURSOR OFF.
*
*----------------------------------------------------------------------------

  PRIVATE lc_anykey, lc_msg, lc_msglen, lc_win, ln_press, ln_width, ll_trap,;
          ll_escape

  lc_anykey = [Press any key to continue...]
  ln_press  = LEN( lc_anykey )
  lc_win = WINDOW()                     && Currently activated window if any
  lc_msg = LTRIM( RTRIM( pc_msg ) )     && Trimmed message
  ln_msglen = LEN( lc_msg )             && Trimmed length of message
  ln_width = 0                          && Width of display area in window.
  ll_escape = SET("ESCAPE") = "ON"
  IF TYPE( "FXL_DEV" ) = "L" .AND. FXL_DEV
    SET ESCAPE ON
  ELSE
    SET ESCAPE OFF
  ENDIF

  *-- Determine the width needed for the window:
  IF ln_msglen <= ln_press
    ln_width = ln_press
  ELSE
    *-- Make sure the message fits in the window:
    IF ln_msglen > 76
      lc_msg = LEFT( lc_msg, 76 )
      ln_msglen = 76
    ENDIF
    ln_width = ln_msglen
  ENDIF
  lc_CoMess = ColorChk( "M" )
  DEFINE WINDOW Err_Box FROM 9, ((76 - ln_width) + .5) / 2 ;
                TO 15, (ln_width + 83) / 2 DOUBLE ;
     COLOR &lc_CoMess

  ln_width = ( ln_width + 2 )

  *-- Display the message and prompt to the window and wait for a key press
  IF pl_shadow
    SAVE SCREEN TO Err_Box
    DO ShadowG WITH 9, ;
                    ((76 - ln_width) + .5) / 2, ;
                    15, ;
                    (ln_width + 83) / 2
  ENDIF
  ACTIVATE WINDOW Err_Box
  @ 1, ( ln_width - ln_msglen ) / 2 SAY lc_msg
  @ 3, ( ln_width - ln_press ) / 2 SAY lc_anykey
  SET CONSOLE OFF                       && For mouse click recognition
  WAIT
  SET CONSOLE ON

  *-- Clean up the window display and reactivate the previous window
  RELEASE WINDOW Err_Box
  IF ISBLANK( lc_win )
    ACTIVATE SCREEN
  ENDIF
  IF pl_shadow
    RESTORE SCREEN FROM Err_Box
    RELEASE SCREEN Err_Box
  ENDIF

  IF ll_escape
    SET ESCAPE ON
  ELSE
    SET ESCAPE OFF
  ENDIF

RETURN
*-- EOP: Err_Box WITH pc_msg



FUNCTION ColorChk
PARAMETERS pc_WhichCo
*---------------------------------------------------------------------
* NAME
*   ColorChk - Return a specific color attribute setting.
*
* SYNOPSIS
*   ColorChk( pc_WhichCo )
*
* DESCRIPTION
*   ColorChk() returns a string representing one of eight
*   possible color attribute values.  The first letters of
*   the argument string mean the following.  (These are listed
*   in the same order as they are returned by SET("ATTRIBUTES".
*   Upper or lower case may be used.)
*
*   "N" - Normal.
*   "H" - Highlight.
*   "P" - Perimeter.
*   "M" - Messages.
*   "T" - Titles.
*   "B" - Box.
*   "I" - Information.
*   "F" - Fields.
*
*   The string returned is of the pattern: <foreground/background>.
*   Letters are used to represent specific colors.  For example,
*   the string "W+/B" indicates bright white on blue.  The dBASE IV
*   documentation includes detailed explanation of these codes.
*
* NOTE
*   Since only the first letter of the argument is used, the
*   full words can be used for greater code readability.  Thus,
*   the following three sample lines of code are identical:
*
*     lc_fldclr = ColorChk( "f" )
*     lc_fldclr = ColorChk( "FIELDS" )
*     lc_fldclr = ColorChk( "Fuzzy wuzzy" )
*
* PARAMETERS
*   pc_WhichCo = The single letter or string indicating which color
*                attribute string to return.
*
* LIMITATIONS
*   ColorChk() does not test for valid arguments.
*   An argument starting with a letter other than the eight
*   listed above will return the Normal color setting string.
*
* SEE ALSO:
*   SET("ATTRIBUTES"), SET COLOR
*
*---------------------------------------------------------------------

  PRIVATE lc_colattr, lc_whichco, ln_count, ln_stop_at, lc_attrib

  lc_whichco = UPPER(LEFT(pc_whichco,1))
  lc_attrib  = SET("ATTRIBUTE")

  IF lc_whichco $ "MTBIF"
    lc_colattr = SUBSTR(lc_attrib, AT("&", lc_attrib) + 2)
  ELSE
    lc_colattr = LEFT(lc_attrib, AT("&", lc_attrib) - 2)
  ENDIF

  DO CASE
    CASE lc_whichco = "F"
      ln_stop_at = 4
    CASE lc_whichco = "I"
      ln_stop_at = 3
    CASE lc_whichco $ "BP"
      ln_stop_at = 2
    CASE lc_whichco $ "TH"
      ln_stop_at = 1
    OTHERWISE
      ln_stop_at = 0
  ENDCASE

  ln_count = 1

  DO WHILE m->ln_count <= m->ln_stop_at
    lc_colattr = SUBSTR(m->lc_colattr, AT(",", m->lc_colattr) + 1)
    ln_count = m->ln_count + 1
  ENDDO

RETURN IIF("," $ lc_colattr, ;
            LEFT(lc_colattr, AT(",", lc_colattr) - 1), ;
            lc_colattr ;
          )
*-- EOF:  ColorChk( pc_WhichCo )



FUNCTION StrInBox
PARAMETERS pn_row, pn_col, pc_prompt, pc_str, pn_maxlen, pn_scroll
*---------------------------------------------------------------------
* NAME
*   StrInBox - Get a string in a box
*
* DESCRIPTION
* 	This routine implements the fill-in popup to get a string
* 	from the user.	The box dimensions are determined on the
* 	fly depending upon the prompt length and the scroll_len.
* 	The height of the box is assumed to be 3.
*
* 	If an error is encountered during processing, that error is displayed
* 	with a beep and we return -1 with the original string value
* 	remaining unchanged.  If the user hits ESCAPE key then also -1
* 	is returned (without changing the original string value) and the
* 	caller should take appropriate action (may be no action).
*
*
* SYNOPSIS
*
* PARAMETERS
*   pn_row      = Top row position
*   pn_col      = Left column position
*   pc_prompt   = Prompt inside of the box
*   pc_str      = Starting value
*   pn_maxlen   = Maximum length of the string
*   pn_scroll   = Scroll length for the input string
*
* LIMITATIONS
*
* DEPENDENCIES
*
*---------------------------------------------------------------------
  PRIVATE ll_deli, lc_str, lc_pict, ll_confirm, ln_rtn, ln_inboxw, ;
          ln_getcol, lc_window

  ll_deli = SET("DELIMITER") = "ON"
  SET DELIMITER OFF
  ll_confirm = SET("CONFIRM") = "ON"
  SET CONFIRM ON

  lc_window = WINDOW()

  ln_inboxw = LEN( pc_prompt ) + 3 + pn_scroll
  lc_str = pc_str + SPACE( pn_maxlen - LEN( pc_str ) )
  DEFINE WINDOW StrInBox FROM pn_row, pn_col ;
                         TO pn_row+2, pn_col+ln_inboxw+1 DOUBLE
  ACTIVATE WINDOW StrInBox
  @ 0,0 SAY [ ] + pc_prompt + [  ]

  lc_pict = "@S" + LTRIM( STR( pn_scroll, 3 ) )
  ln_getcol = ln_inboxw - pn_scroll
  ln_rtn = 0

  DO WHILE .T.
    @ 0, ln_getcol GET lc_str PICTURE ( lc_pict )
    READ
    ln_lastkey = LASTKEY()
    IF ln_lastkey = 27
      ln_rtn = -1
    ELSE
      pc_str = lc_str
    ENDIF

    EXIT
  ENDDO

  IF ll_deli
    SET DELIMITER ON
  ENDIF
  IF .NOT. ll_confirm
    SET CONFIRM OFF
  ENDIF
  SET CURSOR ON

  RELEASE WINDOW StrInBox
  IF .NOT. ISBLANK( lc_window )
    ACTIVATE WINDOW &lc_window
  ENDIF

RETURN( ln_rtn )
*-- EOF:  StrInBox( pn_row, pn_col, pc_prompt, pc_str, pn_max, pn_scroll )




FUNCTION MakeLook   && UDS - Make BROWSE/POPUP Look-Up String
PARAMETER pc_form   && Format file name
*-----------------------------------------------------------------------------
*-- Notes......: Produces Form.gen browse/popup screen in the form designer
*-- Files......: Creates files with a .scm or .scx extension
*-----------------------------------------------------------------------------
  PRIVATE lc_talk, ln_options, lc_form, ln_options, ln_rtn

  IF SET( "TALK") = "ON"
    SET TALK OFF
    lc_talk = "ON"
  ELSE
    lc_talk = "OFF"
  ENDIF

  SET FORMAT TO

  IF PCOUNT() = 0 .OR. ISBLANK( pc_form )
    lc_form = SPACE(8)

    ln_rtn  = StrInBox( 7, 10, "Enter in the save file name: ", ;
                          lc_form, 8, 8 )
    IF ln_rtn = -1 .OR. ISBLANK( lc_form )
      DO Err_Box WITH "MakeLook() will not save the lookup parameters"
    ENDIF
    lc_form = TRIM( UPPER( lc_form ) )
  ELSE
    lc_form = TRIM( UPPER( pc_form ) )
  ENDIF

  lc_form = IIF( ".FMT" $ lc_form, ;
                 LEFT( lc_form, AT( ".FMT", lc_form ) - 1 ) , ;
                 lc_form) + ".scm"

  *-- Session properties
  ln_options = 12                      && Number of options in Makelook
  DECLARE params[3]
  params[1] = .F.                      && Lookup file open for this popup
  params[2] = ""                       && ALIAS of the open lookup file
  params[3] = ALIAS()                  && Current ALIAS that is in USE

  SELECT SELECT()                      && Avoids GETing of the OPEN FORMAT file

  IF FILE( (lc_form) )                     && Design info not stored
    RESTORE FROM ( lc_form ) ADDITIVE      && Restore the User's requests
    params[1] = .t.                        && .dbf already designed
    USE ( dv_lookup[01] )                  && Open up the lookup file
    params[2] = ALIAS()
  ELSE
    *-- Attribute bar titles for the popup
    DECLARE bt_lookup[ln_options]
    bt_lookup[01] = " Lookup file                  "
    bt_lookup[02] = " Return field                 "
    bt_lookup[03] = " Tag for lookup               "
    bt_lookup[04] = " Browse                       "
    bt_lookup[05] = " Fields list                  "
    bt_lookup[06] = " Window coordinates           "
    bt_lookup[07] = " Allow updates to lookup file "
    bt_lookup[08] = " Name of format file          "
    bt_lookup[09] = " Shadow                       "
    bt_lookup[10] = " Permit blank field values    "
    bt_lookup[11] = " Zoom to form                 "
    bt_lookup[12] = " Replace Fields               "

    *-- Attribute bar messages for the popup
    DECLARE mt_lookup[ln_options]
    mt_lookup[01] = "Enter the Lookup File Name for Field Validation"
    mt_lookup[02] = "Enter the Field Value to Return to the Active GET"
    mt_lookup[03] = "Enter the Order Tag for SEEKing"
    mt_lookup[04] = "Toggle Browse or Popup for the Picklist"
    mt_lookup[05] = "Enter the Fields List for the Browse Picklist - OPTIONAL"
    mt_lookup[06] = "Enter the Window Coordinates for Browse Picklist - OPTIONAL"
    mt_lookup[07] = "Allow APPENDing of New Records in the Browse Picklist"
    mt_lookup[08] = "Enter the Name of the FORMAT File for the Browse Picklist - OPTIONAL"
    mt_lookup[09] = "Apply Shadowing Affects to the Picklist"
    mt_lookup[10] = "Allow Blank Data on Return to the Active GET"
    mt_lookup[11] = "Enter the Name of the FORMAT File for the ZOOMed Edit - OPTIONAL"
    mt_lookup[12] = "Allow Additional Replaces to take place during Lookup - OPTIONAL"

    *-- Default values for the popup
    DECLARE dv_lookup[ln_options]
    dv_lookup[01] = SPACE(80)
    dv_lookup[02] = SPACE(10)
    dv_lookup[03] = SPACE(10)
    dv_lookup[04] = "YES"
    dv_lookup[05] = SPACE(80)
    dv_lookup[06] = "14,00 TO 20,79"
    dv_lookup[07] = "NO"
    dv_lookup[08] = SPACE(80)
    dv_lookup[09] = "NO"
    dv_lookup[10] = "YES"
    dv_lookup[11] = SPACE(80)
    dv_lookup[12] = "NO"

    *-- Array for the REPLACE string
    DECLARE ac_replace[4]
    STORE SPACE(254) TO ac_replace[1], ac_replace[2], ac_replace[3], ac_replace[4]

    *-- Action performed then option is selected
    DECLARE ap_lookup[ln_options]
    ap_lookup[01] = "GET"
    ap_lookup[02] = "GET"
    ap_lookup[03] = "GET"
    ap_lookup[04] = "TOGGLE"
    ap_lookup[05] = "GET"
    ap_lookup[06] = "GET"
    ap_lookup[07] = "TOGGLE"
    ap_lookup[08] = "GET"
    ap_lookup[09] = "TOGGLE"
    ap_lookup[10] = "TOGGLE"
    ap_lookup[11] = "GET"
    ap_lookup[12] = "TOGGLE"

    *-- Assist actions in the event of a SHIFT-F1 Pick List
    DECLARE aa_lookup[ln_options]
    aa_lookup[01] = "FILES LIKE *.DBF"
    aa_lookup[02] = "FIELDS"
    aa_lookup[03] = "TAGS"
    aa_lookup[04] = ""
    aa_lookup[05] = "FIELDS CONTINUE"
    aa_lookup[06] = ""
    aa_lookup[07] = ""
    aa_lookup[08] = "FILES LIKE *.FMT"
    aa_lookup[09] = ""
    aa_lookup[10] = ""
    aa_lookup[11] = "FILES LIKE *.FMT"
    aa_lookup[12] = "FIELDS CONTINUE"

  ENDIF

  SET BORDER TO DOUBLE

  DEFINE POPUP lookup FROM 8,9 TO 21,70
  DEFINE BAR  1 OF lookup PROMPT bt_lookup[01] + dis_val( 01 ) ;
    MESSAGE mt_lookup[01]
  DEFINE BAR  2 OF lookup PROMPT bt_lookup[02] + dis_val( 02 ) ;
    MESSAGE mt_lookup[02]
  DEFINE BAR  3 OF lookup PROMPT bt_lookup[03] + dis_val( 03 ) ;
    MESSAGE mt_lookup[03]
  DEFINE BAR  4 OF lookup PROMPT bt_lookup[04] + dis_val( 04 ) ;
    MESSAGE mt_lookup[04]
  DEFINE BAR  5 OF lookup PROMPT bt_lookup[05] + dis_val( 05 ) ;
    MESSAGE mt_lookup[05] ;
    SKIP FOR bt_lookup[04] = "NO"
  DEFINE BAR  6 OF lookup PROMPT bt_lookup[06] + dis_val( 06 ) ;
    MESSAGE mt_lookup[06] ;
    SKIP FOR bt_lookup[04] = "NO"
  DEFINE BAR  7 OF lookup PROMPT bt_lookup[07] + dis_val( 07 ) ;
    MESSAGE mt_lookup[07] ;
    SKIP FOR bt_lookup[04] = "NO"
  DEFINE BAR  8 OF lookup PROMPT bt_lookup[08] + dis_val( 08 ) ;
    MESSAGE mt_lookup[08] ;
    SKIP FOR bt_lookup[04] = "NO"
  DEFINE BAR  9 OF lookup PROMPT bt_lookup[09] + dis_val( 09 );
    MESSAGE mt_lookup[09]
  DEFINE BAR 10 OF lookup PROMPT bt_lookup[10] + dis_val( 10 );
    MESSAGE mt_lookup[10]
  DEFINE BAR 11 OF lookup PROMPT bt_lookup[11] + dis_val( 11 ) ;
    MESSAGE mt_lookup[11]
  DEFINE BAR 12 OF lookup PROMPT bt_lookup[12] + dis_val( 12 ) ;
    MESSAGE mt_lookup[12]

  ON SELECTION POPUP lookup DO hp_lookup

  SET CURSOR OFF  
  ll_ctrlend = .f.
  ON KEY LABEL Ctrl-End DO BailSave

  SAVE SCREEN TO makelook

  gc_status = SET("STATUS")
  SET STATUS OFF
  RESTORE SCREEN FROM makelook

  DO key_vars                          && Assign keystroke variables

  ACTIVATE POPUP lookup

  SET MESSAGE TO "" AT 24
  SET STATUS &gc_status.
  RESTORE SCREEN FROM makelook
  RELEASE SCREEN makelook

  ON KEY LABEL Ctrl-End
  SET CURSOR ON

  IF ll_ctrlend 
    ln_typeahd = SET( "TYPEAHEAD" )
    SET TYPEAHEAD TO 254

    CLEAR TYPEAHEAD

    IF dv_lookup[04] = "YES"           && Set up browse string
      
      KEYBOARD CHR(kn_Enter) + CHR(kn_Home) + CHR(kn_CtrlY) + ["BROWSE"="] + ;
               LOWER( TRIM( dv_lookup[01] ) ) + [->] + ;
               LOWER( TRIM( dv_lookup[02] ) ) + [ ORDER ] + ;
               LOWER( TRIM( dv_lookup[03] ) ) + [ ]

      KEYBOARD IIF( ISBLANK( dv_lookup[05] ), ;
                    "", ;
                    [FIELDS ] + LOWER( ALLTRIM( dv_lookup[05] ) ) + [ ] )  + ;
               IIF( ISBLANK( dv_lookup[06] ), ;
                    "", ;
                    [FROM ] + LOWER( ALLTRIM( dv_lookup[06] ) ) + [ ] )  + ;
               IIF( dv_lookup[07] = "YES", ;
                    [UPDATE ], ;
                    "")

      KEYBOARD IIF( ISBLANK( dv_lookup[08] ) , ;
                    "", ;
                    [FORMAT ] + LOWER( ALLTRIM( dv_lookup[08] ) ) + [ ] )

      KEYBOARD IIF( dv_lookup[12] = "YES", ;
                    [REPLACE ] + ;
                    IIF( LEN( TRIM( ac_replace[1]) + TRIM( ac_replace[2]) +;
                         TRIM( ac_replace[3]) + TRIM( ac_replace[4])) <= 100,;
                            LOWER( ALLTRIM( ac_replace[1] )) + ;
                            LOWER( ALLTRIM( ac_replace[2] )) + ;
                            LOWER( ALLTRIM( ac_replace[3] )) + ;
                            LOWER( ALLTRIM( ac_replace[4] )) + ;
                            + [ ], ;
                            "";
                       ), ;
                    "")

      KEYBOARD IIF( dv_lookup[09] = "YES", ;
                    [SHADOW ], ;
                    "") + ;
               IIF( dv_lookup[10] = "NO", ;
                    [REQ ], ;
                    "")  + ;
               IIF( ISBLANK( dv_lookup[11] ) , ;
                    "", ;
                    [ZOOM ] + LOWER( ALLTRIM( dv_lookup[11] ) ) ) + ["] + ;
                    CHR(kn_Enter)

      *-- Output REPLACE string to file so that Form.gen will read this.
      *-- If it is greater that 100 characters
      IF LEN(TRIM( ac_replace[1]) + TRIM( ac_replace[2]) +;
             TRIM( ac_replace[3]) + TRIM( ac_replace[4])) > 100

          SET DEVICE TO FILE (lc_form + ".scx")
          @ 0,0 SAY ALLTRIM( ac_replace[1]) + ALLTRIM( ac_replace[2]) + ;
                    ALLTRIM( ac_replace[3]) + ALLTRIM( ac_replace[4])
          SET DEVICE TO SCREEN
      ENDIF

    ELSE
      KEYBOARD CHR(kn_Enter) + CHR(kn_Home) + CHR(kn_CtrlY) + ["POPUP"="] + ;
               LOWER( TRIM( dv_lookup[01] ) ) + [->] + ;
               LOWER( TRIM( dv_lookup[02] ) ) + [ ORDER ] + ;
               LOWER( TRIM( dv_lookup[03] ) ) + [ ] + ;
               IIF( dv_lookup[09] = "YES", ;
                    [SHADOW ] , ;
                    "") + ;
               IIF( dv_lookup[10] = "NO", ;
                    [REQ ], ;
                    "")

      KEYBOARD IIF( dv_lookup[12] = "YES", ;
                    [REPLACE ] + ;
                    IIF( LEN( TRIM( ac_replace[1]) + TRIM( ac_replace[2]) +;
                         TRIM( ac_replace[3]) + TRIM( ac_replace[4])) <= 100,;
                            LOWER( ALLTRIM( ac_replace[1] )) + ;
                            LOWER( ALLTRIM( ac_replace[2] )) + ;
                            LOWER( ALLTRIM( ac_replace[3] )) + ;
                            LOWER( ALLTRIM( ac_replace[4] )) + ;
                            + [ ], ;
                            "";
                       ), ;
                    "") + ;
                    IIF( ISBLANK( dv_lookup[11] ) , ;
                         "", ;
                         [ZOOM ] + LOWER( ALLTRIM( dv_lookup[11] ) ) ) + ;
                    ["] + CHR(kn_Enter)
    ENDIF
  ENDIF  && ll_ctrlend

  IF params[1]
    USE                                && Close the file in use
    IF .NOT. ISBLANK( params[3] )
      SELECT &params[3].               && Back to the original workarea
    ELSE
      SELECT 1
    ENDIF
  ENDIF
      
  RELEASE POPUP lookup

  DO rele_vars                      && Get rid of Global Variables

  IF ll_ctrlend
     *-- Get rid of other varialbes we don't want to save the .scm file
     RELEASE params, zz_talk, ll_ctrlend, ln_options, ln_typeahd, gc_status
     SET SAFETY OFF
     SAVE TO ( lc_form ) ALL EXCEPT lc_talk     && Save the User's requests
     SET SAFETY ON
  ENDIF

  RELEASE bt_lookup, dv_lookup, ap_lookup, ac_replace, mt_lookup,;
          aa_lookup, lc_form

  SET TALK &lc_talk.

RETURN( .t. )
*-- EOF: MakeLook( lc_form )


PROCEDURE BailSave  && UDS - Makelook()
*-------------------------------------------------------------------
* Control-End pressed by the user, save that fact and KEYBOARD Esc
* out of the dialog box
*-------------------------------------------------------------------
  ll_ctrlend = .T.
  KEYBOARD CHR( kn_Esc )
RETURN
*-- EOP: BailSave


PROCEDURE Hp_Lookup && UDS - Makelook()
*-------------------------------------------------------------------
* User selected one of the dialog box bars, call the routine to
* handle either a GET or TOGGLE operation.
*-------------------------------------------------------------------
  bar_value = BAR()
  IF ap_lookup[ bar_value ] = "TOGGLE"
    DO bar_togg WITH bar_value
  ELSE
    DO bar_get WITH bar_value
  ENDIF
RETURN 
*-- EOP: Hp_Lookup


PROCEDURE Bar_Togg  && UDS - Makelook()
PARAMETER pn_bn
*-------------------------------------------------------------------
* Toggle a YES / NO bar when the user selected the dialog bar.
*-------------------------------------------------------------------
  dv_lookup[ pn_bn ] = IIF( dv_lookup[ pn_bn ] = "YES", "NO", "YES")
  pc_bn = STR( pn_bn, 2 )

  *-- Handle dimming action based on the BROWSE or POPUP
  IF pn_bn = 4 .AND. dv_lookup[ pn_bn ] = "NO"
    DEFINE BAR  5 OF lookup PROMPT bt_lookup[05] + dis_val( 05 ) SKIP
    DEFINE BAR  6 OF lookup PROMPT bt_lookup[06] + dis_val( 06 ) SKIP
    DEFINE BAR  7 OF lookup PROMPT bt_lookup[07] + dis_val( 07 ) SKIP
    DEFINE BAR  8 OF lookup PROMPT bt_lookup[08] + dis_val( 08 ) SKIP
  ELSE
    IF pn_bn = 4
      DEFINE BAR  5 OF lookup PROMPT bt_lookup[05] + dis_val( 05 );
        MESSAGE mt_lookup[05]
      DEFINE BAR  6 OF lookup PROMPT bt_lookup[06] + dis_val( 06 ) ;
        MESSAGE mt_lookup[06]
      DEFINE BAR  7 OF lookup PROMPT bt_lookup[07] + dis_val( 07 ) ;
        MESSAGE mt_lookup[07]
      DEFINE BAR  8 OF lookup PROMPT bt_lookup[08] + dis_val( 08 ) ;
        MESSAGE mt_lookup[08]
    ENDIF
  ENDIF

  DEFINE BAR &pc_bn OF lookup PROMPT bt_lookup[ pn_bn ] + dv_lookup[ pn_bn ] ;
     MESSAGE mt_lookup [ pn_bn ]

  IF pn_bn = 12 .AND. dv_lookup[ pn_bn ] = "YES"
     lc_colorfld = color("FIELDS")
     lc_colorbox = color("BOX")
     ON KEY LABEL Ctrl-End
     SAVE SCREEN TO replace
     @ 14,10 TO 19,69 DOUBLE COLOR &lc_colorbox.
     SET CURSOR ON
     SET MESSAGE TO "Enter Replace Statements.   Format <f1 WITH f2 [, f3 WITH f4]>"

     DECLARE ac_teplace[4]             && Temporary array for editing replace values
     ac_teplace[1] = ac_replace[1]
     ac_teplace[2] = ac_replace[2]
     ac_teplace[3] = ac_replace[3]
     ac_teplace[4] = ac_replace[4]

     ON KEY LABEL Shift-F1 DO hand_pick WITH pn_bn, VARREAD()
     DO WHILE .T.
        @ 15,11 GET ac_teplace[1] PICTURE "@S58" COLOR &lc_colorfld.
        @ 16,11 GET ac_teplace[2] PICTURE "@S58" COLOR &lc_colorfld.
        @ 17,11 GET ac_teplace[3] PICTURE "@S58" COLOR &lc_colorfld.
        @ 18,11 GET ac_teplace[4] PICTURE "@S58" COLOR &lc_colorfld.
        READ
        IF READKEY() = 270              && CTRL-END, save new values
           ac_replace[1] = ac_teplace[1]
           ac_replace[2] = ac_teplace[2]
           ac_replace[3] = ac_teplace[3]
           ac_replace[4] = ac_teplace[4]
           EXIT
        ENDIF
        IF READKEY() = 12               && Esc, leave old values
           EXIT
        ENDIF
     ENDDO
     RELEASE ac_teplace
     SET CURSOR OFF
     ON KEY LABEL Shift-F1
     ON KEY LABEL Ctrl-End DO BailSave
     SET MESSAGE TO
     RESTORE SCREEN FROM replace
     RELEASE SCREEN replace
  ENDIF
RETURN
*-- EOP: Bar_Togg WITH pn_bn


PROCEDURE Bar_Get   && UDS - MakeLook()
*-------------------------------------------------------------------
* Get the value within the braces
*-------------------------------------------------------------------
PARAMETER pn_bn

  PRIVATE ll_invalid, ll_zoomed, ll_msg, ln_row, ln_col, lc_colorfld

  SET MESSAGE TO "" AT 23

  *-- Set up the Shift-F1 pick list if desired
  IF .NOT. ISBLANK( aa_lookup[ pn_bn ] )
    ON KEY LABEL Shift-F1 DO hand_pick WITH pn_bn, VARREAD()
    ll_msg =  "Pick operators/fields: Shift-F1    Zoom: F9    Accept: " + ;
              CHR(17) + CHR(196) + CHR(217) + "    Cancel: Esc"
  ELSE
    ll_msg =  "Zoom: F9    Accept: " + CHR(17) + CHR(196) + CHR(217) + ;
              "    Cancel: Esc"
  ENDIF

  *-- Set up F9 Zoom key
  ON KEY LABEL F9 DO zoom_get

  IF pn_bn = 6
     *-- Set up F4 Size Box  key
     ON KEY LABEL F4 KEYBOARD( CHR(kn_Home) + CHR(kn_CtrlY) + MakeWind() )
     ll_msg = "Design window: F4   " + ll_msg
  ENDIF

  SET CURSOR ON
  lc_prevval = dv_lookup[ pn_bn ]
  ln_row = ROW()
  ln_col = 39
  lc_colorfld = color("FIELDS")
  ll_zoomed = .f.
  ll_invalid = .t.
  lc_pict = "@S30!"
  @ ln_row, ln_col SAY SPACE( LEN( dis_val( pn_bn ) ) ) COLOR &lc_colorfld
  SAVE SCREEN TO bar_get
  DO WHILE ll_invalid
     @ ln_row, ln_col+1 GET dv_lookup[ pn_bn ] PICTURE (lc_pict) ;
       MESSAGE ll_msg
     READ
     IF ln_row = 21
        RESTORE SCREEN FROM bar_get
     ENDIF
     IF .NOT. ll_zoomed
        DO val_get WITH ll_invalid, pn_bn   && ll_invalid will be set .F. if OK
        ON KEY LABEL F9 DO zoom_get         && Re-enable Zoom when not zoomed
     ELSE
        ll_zoomed = .f.
        ON KEY LABEL F9                     && Prevent Zoom from Zoom for now
        @ ln_row, ln_col SAY space(80) COLOR &lc_colorfld
     ENDIF
  ENDDO

  IF READKEY() <> 12                    && Escape not pressed
    pc_bn = STR( pn_bn, 2 )
    DEFINE BAR &pc_bn OF lookup PROMPT bt_lookup[ pn_bn ] + dis_val( pn_bn );
       MESSAGE mt_lookup[ pn_bn ]
  ELSE
    dv_lookup[ pn_bn ] = lc_prevval
  ENDIF

  SET CURSOR OFF

  ON KEY LABEL F4
  ON KEY LABEL F7
  ON KEY LABEL F9
  ON KEY LABEL Shift-F1

  SET MESSAGE TO mt_lookup[ pn_bn ] AT 24
  RELEASE SCREEN bar_get

RETURN
*-- EOP: Bar_Get WITH pn_bn


FUNCTION MakeWind   && UDS - MakeLook()
*-------------------------------------------------------------------
* Calls the Window "movehand'ler" to create a box and returns 
* the coordinates
*-------------------------------------------------------------------
  PRIVATE lc_string
  lc_string = UPPER( dv_lookup[06])
  lc_string = STUFF( lc_string, AT("TO", lc_string), 2, ",")
RETURN ( movehand( "DOUBLE"+ "," + lc_string ) )
*-- EOF: MakeWind()


PROCEDURE Val_Get   && UDS - MakeLook()
*-------------------------------------------------------------------
* Validate the GET value for the dialog box bar
*-------------------------------------------------------------------
PARAMETER ll_return, pn_bn
  ll_return = .f.
RETURN
*-- EOP: Val_Get WITH ll_return, pn_bn


PROCEDURE Zoom_Get  && UDS - MakeLook()
*-------------------------------------------------------------------
* Handle the user's request to F9 - ZOOM on a GET
*-------------------------------------------------------------------
  ln_row = 21
  ln_col = 0
  lc_pict = "@S80!"
  ll_zoomed = .T.
  KEYBOARD CHR( kn_Enter)
RETURN
*-- EOP: Zoom_Get

FUNCTION Dis_Val    && UDS - MakeLook()
PARAMETER pn_bar
*-------------------------------------------------------------------
* Re-Display the GET value within the braces when the user presses
* the Enter key.
*-------------------------------------------------------------------
  PRIVATE lc_result

  IF ap_lookup[ pn_bar ] = "TOGGLE"
    lc_result = dv_lookup[ pn_bar ]
  ELSE
    IF LEN( ALLTRIM( dv_lookup[ pn_bar ] ) ) > 27
      lc_result = "{" + ;
                  LEFT( ALLTRIM( dv_lookup[ pn_bar ] ), 27 ) + ;
                  "}"
    ELSE
      lc_result = "{" + ALLTRIM( dv_lookup[ pn_bar ] ) + "}"
    ENDIF
  ENDIF
RETURN( lc_result )
*-- EOF: Dis_Val( pn_bar )

PROCEDURE Hand_Pick && UDS - MakeLook()
PARAMETER pn_bn, lc_field
*-------------------------------------------------------------------
* Handle the selection of an item from the various picklists
*-------------------------------------------------------------------

  ON KEY LABEL Shift-F1   && Disable Shift-F1 to prevent recursion

  PRIVATE lc_prompt, lc_window, ln_barnum, ln_tagnum

  lc_prompt = SPACE( 80 )
  lc_window = WINDOW()
  IF .NOT. ISBLANK( lc_window)
     ACTIVATE SCREEN
  ENDIF
  DO CASE                  

    CASE ISBLANK( aa_lookup[ pn_bn ] )
      lc_prompt = ""
      DO Beep

    CASE LEFT( aa_lookup[ pn_bn ], 6 ) = "FIELDS"
      IF params[1]                     && Lookup file is open
        DEFINE POPUP picklist PROMPT STRUCTURE FROM 5, 10
        ON SELECTION POPUP picklist DEACTIVATE POPUP
        IF pn_bn = 12 
           IF UPPER( RIGHT( TRIM( &lc_field), 4 ) ) = "WITH"
              ll_in_with = .T.
              SELECT ( params[2] )
           ELSE
              ll_in_with = .F.
              SELECT ( params[3] )
           ENDIF
        ENDIF

        ACTIVATE POPUP picklist
        lc_prompt = IIF( ISBLANK( PROMPT() ), "", ALLTRIM( PROMPT() ) )
        RELEASE POPUP picklist

        SELECT ( params[2] )           && Return to Correct work area
      ENDIF


    CASE aa_lookup[ pn_bn ] = "TAGS"
      IF params[1]

        IF ISBLANK( MDX( 1 ) )
          ln_barnum = 1
        ELSE
          ln_barnum = 3
          ln_tagnum = 1
          DO WHILE .NOT. ISBLANK( TAG( ln_tagnum ) )
            ln_barnum = ln_barnum + 1
            ln_tagnum = ln_tagnum + 1
          ENDDO
        ENDIF
        ln_newbot = MAX( 7, MIN( 5 + ln_barnum, 17 ) )
        DEFINE POPUP mdxlist FROM 5, 10 TO (ln_newbot), 70

        IF ln_barnum = 1
          DEFINE BAR 1 OF mdxlist PROMPT "NO MDX TAGS EXIST - PRESS Esc" SKIP
        ELSE
          DEFINE BAR 1 OF mdxlist PROMPT "TAG NAME  KEY EXPRESSION" SKIP
          DEFINE BAR 2 OF mdxlist PROMPT REPLICATE( "", 10 ) + CHR(197) +;
                                         REPLICATE( "", 48 ) SKIP
          ln_barnum = 3
          ln_tagnum = 1
          DO WHILE .NOT. ISBLANK( TAG( ln_tagnum ) )
            DEFINE BAR ln_barnum OF mdxlist ;
              PROMPT LEFT( TAG( ln_tagnum ) + SPACE(10), 10 ) + "" + ;
                     UPPER( KEY( ln_tagnum ) )
            ln_barnum = ln_barnum + 1
            ln_tagnum = ln_tagnum + 1
          ENDDO
        ENDIF           

        ON SELECTION POPUP mdxlist DEACTIVATE POPUP
        ACTIVATE POPUP mdxlist                     

        IF BAR() > 2
          lc_prompt = ALLTRIM( LEFT( PROMPT(),10 ) )
        ELSE
          lc_prompt = ""
        ENDIF

        RELEASE POPUP mdxlist

      ENDIF && params[1]

    OTHERWISE  && File Like
      DEFINE POPUP picklist PROMPT &aa_lookup[ pn_bn ] FROM 5, 10
      ON SELECTION POPUP picklist DEACTIVATE POPUP
      ACTIVATE POPUP picklist
      IF .NOT. ISBLANK( PROMPT() )
        lc_prompt = ALLTRIM( PROMPT() )
        *-- Get rid of file extensions and path info
        lc_prompt = TRIM( SUBSTR( lc_prompt, RAT( "\", lc_prompt ) + 1 ) )
        lc_prompt = IIF( ".DBF" $ UPPER( lc_prompt ) .OR. ;
                         ".FMT" $ UPPER( lc_prompt ), ;
                        LEFT( lc_prompt, LEN( lc_prompt ) - 4), ;
                        lc_prompt ;
                       )
        IF AT( "DBF", aa_lookup[ pn_bn ] ) > 0
          USE                          && Close current .dbf file
          params[1] = .t.
          SELECT SELECT()
          USE ( lc_prompt )            && Open up current selected file
          params[2] = ALIAS()
        ENDIF

      ELSE
        lc_prompt = ""
      ENDIF
      RELEASE POPUP picklist

  ENDCASE

  IF .NOT. ISBLANK( lc_prompt )
    ln_typeahd = SET( "TYPEAHEAD" )
    SET TYPEAHEAD TO 254

    IF AT( "CONTINUE", aa_lookup[05] ) > 0
      KEYBOARD IIF(pn_bn <> 12, CHR(kn_End), "" ) + lower( lc_prompt )
      IF pn_bn = 12                    && In "Replace Fields" logic
         KEYBOARD IIF( .NOT. ll_in_with , [ WITH ], [, ]) +;
                  CHR(kn_DownArw) + CHR(kn_UpArw) + CHR(kn_End) + CHR(kn_space);
                  && The Down, Up Arrow force the update of the GET buffer
      ENDIF
    ELSE
      KEYBOARD CHR(kn_Home) + CHR(kn_Home) + CHR(kn_CtrlY) + ;
               lc_prompt + CHR(kn_Enter) CLEAR
    ENDIF

    SET TYPEAHEAD TO ln_typeahd
  ENDIF

  ON KEY LABEL Shift-F1 DO hand_pick WITH pn_bn, VARREAD()
  IF .NOT. ISBLANK( lc_window )
     ACTIVATE WINDOW &lc_window.
  ENDIF
RETURN
*-- EOP: Hand_Pick WITH pn_bn

FUNCTION MoveHand   && UDS - MakeLook()
PARAMETER p_wintype
*-------------------------------------------------------------------
* Handle the user input for keypresses to move the window around
* the screen.
*-------------------------------------------------------------------

   IF TYPE("kn_esc") = "U"
      DO key_vars
   ENDIF

   IF LEFT(p_wintype,6) = "DOUBLE"
      IF LEN(p_wintype) > 6
         DO drawbox WITH "NEW_DOUBLE" + SUBSTR( p_wintype, 7)
      ELSE
         DO drawbox WITH "NEW_DOUBLE"
      ENDIF
   ELSE
      IF LEN(p_wintype) > 6
         DO drawbox WITH "NEW_SINGLE" + SUBSTR( p_wintype, 7)
      ELSE
         DO drawbox WITH "NEW_SINGLE"
      ENDIF
   ENDIF

   ll_f7hit = .t.
   lc_result = ""
   KEYBOARD chr( kn_enter) CLEAR
   @ 1, 1 GET lc_result;
      MESSAGE IIF( ll_f7hit , [Size: Shift-F7], [Drag: F7] ) + ;
      [  Position: ]+CHR(27)+CHR(26)+CHR(25)+CHR(24)+[   Accept: Ctrl-End   Cancel: Esc]
   READ
   ln_key = 0

   DO WHILE ln_key <> kn_Esc .AND. ln_key <> kn_CtrlEnd
      ln_key = INKEY(0)
      DO CASE
         CASE ln_key = kn_F7
            ll_f7hit = .T.
         CASE ln_key = kn_ShftF7
            ll_f7hit = .F.
         CASE ln_key = kn_Home
               DO drawbox WITH gn_home
         CASE ln_key = kn_End
               DO drawbox WITH gn_end
         CASE ln_key = kn_PgUp
               DO drawbox WITH gn_top
         CASE ln_key = kn_PgDn
               DO drawbox WITH gn_bottom
         CASE ln_key = kn_UpArw
            IF ll_f7hit
               DO drawbox WITH gn_moveup
            ELSE
               DO drawbox WITH gn_sizeup
            ENDIF
         CASE ln_key = kn_DownArw
            IF ll_f7hit
               DO drawbox WITH gn_movedn
            ELSE
               DO drawbox WITH gn_sizedn
            ENDIF
         CASE ln_key = kn_RghtArw
            IF ll_f7hit
               DO drawbox WITH gn_movert
            ELSE
               DO drawbox WITH gn_sizert
            ENDIF
         CASE ln_key = kn_LeftArw
            IF ll_f7hit
               DO drawbox WITH gn_movelt
            ELSE
               DO drawbox WITH gn_sizelt
            ENDIF
         CASE ln_key = kn_Esc
            DO drawbox WITH "FREE"
            lc_result = ""
         CASE ln_key = kn_CtrlEnd
            lc_result = TRIM(STR(gn_uptop,2)) + "," + ;
               TRIM(STR(gn_uplft,2)) + " TO " + ;
               TRIM(STR(gn_lobot,2)) + "," + ;
               TRIM(STR(gn_lorgt,2))
            DO drawbox WITH "FREE"
         OTHERWISE
            ?? CHR(7)
      ENDCASE
      IF .NOT. (ln_key = kn_Esc .OR. ln_key = kn_CtrlEnd)
         lc_result = TRIM(STR(gn_uptop,2)) + "," + ;
            TRIM(STR(gn_uplft,2)) + " TO " + ;
            TRIM(STR(gn_lobot,2)) + "," + ;
            TRIM(STR(gn_lorgt,2))
         KEYBOARD CHR( kn_enter) CLEAR
         @ 0, 0 SAY "Window Coordinates: "
         @ 1, 1 GET lc_result;
            MESSAGE IIF( ll_f7hit , [Size: Shift-F7], [Drag: F7] ) + ;
            [  Position: ]+CHR(27)+CHR(26)+CHR(25)+CHR(24)+[   Accept: Ctrl-End   Cancel: Esc]
         READ
         CLEAR GETS
      ENDIF
   ENDDO
RETURN (lc_result)
*-- EOF: MoveHand( p_wintype)

PROCEDURE DrawBox   && UDS - MakeLook()
PARAMETER p_msg
*-------------------------------------------------------------------
* Draw or move the window based on the message passed by MoveHand().
*-------------------------------------------------------------------
IF TYPE("p_msg") = "N"

  DO CASE
    CASE p_msg = gn_sizelt
      IF gn_lorgt - gn_uplft > 6
        gn_lorgt = gn_lorgt - 1
        DO resize
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_sizert
      IF gn_lorgt < 79
        gn_lorgt = gn_lorgt + 1
        DO resize
      ELSE
        DO beep
      ENDIF

    CASE p_msg =  gn_sizeup
      IF gn_lobot - gn_uptop > 5
        gn_lobot = gn_lobot - 1
        DO resize
      ELSE
        DO beep
      ENDIF

    CASE p_msg =  gn_sizedn
      IF gn_lobot < gn_maxlo
        gn_lobot = gn_lobot + 1
        DO resize
      ELSE
        DO Beep
      ENDIF

    CASE p_msg = gn_movelt
      IF gn_uplft > 0
        gn_uplft = gn_uplft - 1
        gn_lorgt = gn_lorgt - 1
        MOVE WINDOW drawbox BY 0,-1
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_moveup
      IF gn_uptop > 0
        gn_uptop = gn_uptop - 1
        gn_lobot = gn_lobot - 1
        MOVE WINDOW drawbox BY -1, 0
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_movedn
      IF gn_lobot < gn_maxlo
        gn_uptop = gn_uptop + 1
        gn_lobot = gn_lobot + 1
        MOVE WINDOW drawbox BY  1, 0
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_movert
      IF gn_lorgt < 79
        gn_uplft = gn_uplft + 1
        gn_lorgt = gn_lorgt + 1
        MOVE WINDOW drawbox BY  0, 1
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_home               && Move window to Left side of screen
      IF gn_uplft > 0
        ln_moved = gn_uplft
        gn_lorgt = ABS(gn_lorgt - gn_uplft)
        gn_uplft = 0
        MOVE WINDOW drawbox BY 0,-ln_moved
      ENDIF

    CASE p_msg = gn_top                && Move window to Top of screen
      IF gn_uptop > 0
        ln_moved = gn_uptop
        gn_lobot = ABS(gn_lobot - gn_uptop)
        gn_uptop = 0
        MOVE WINDOW drawbox BY -ln_moved, 0
      ENDIF

    CASE p_msg = gn_end                && Move window to Right side of screen
      IF gn_lorgt < 79
        ln_moved = 79 - gn_lorgt
        gn_uplft = ln_moved
        gn_lorgt = 79
        MOVE WINDOW drawbox BY 0, ln_moved
      ENDIF

    CASE p_msg = gn_bottom             && Move window to Bottom of screen
      IF gn_lobot < gn_maxlo
        ln_moved = gn_maxlo - gn_lobot
        gn_uptop = ln_moved
        gn_lobot = gn_maxlo
        MOVE WINDOW drawbox BY ln_moved, 0
      ENDIF

  ENDCASE
ELSE
  DO CASE
    CASE LEFT(p_msg,10) = "NEW_DOUBLE"
      DO init_coord WITH p_msg

      gn_wintyp = "DOUBLE"

      DO create_win

    CASE LEFT(p_msg,10) = "NEW_SINGLE"
      DO init_coord WITH p_msg

      gn_wintyp = ""

      DO create_win

    CASE p_msg = "FREE"
      DEACTIVATE WINDOW drawbox
      RELEASE WINDOW drawbox
      RELEASE gn_uptop, gn_uplft, gn_lobot, gn_lorgt, gn_maxlo, gn_wintyp,;
              gn_moveup, gn_movedn, gn_movert, gn_movelt, ;
              gn_sizeup, gn_sizedn, gn_sizert, gn_sizelt, ;
              gn_top, gn_bottom, gn_home, gn_end

  ENDCASE
ENDIF
RETURN
*-- EOP: DrawBox WITH p_msg


PROCEDURE ReSize    && UDS - MakeLook()
*-------------------------------------------------------------------
* Re-define the window when the user resizes the window.
*-------------------------------------------------------------------
   DEACTIVATE WINDOW drawbox
   DEFINE WINDOW drawbox ;
      FROM gn_uptop, gn_uplft TO gn_lobot, gn_lorgt &gn_wintyp.
   ACTIVATE WINDOW drawbox
RETURN
*-- EOP: ReSize


PROCEDURE Beep      && UDS - MakeLook()
*-------------------------------------------------------------------
* Send a beep when the user selects an invalid key.
*-------------------------------------------------------------------
   ?? CHR(7)
RETURN
*-- EOP: Beep

PROCEDURE Init_Coord && UDS - MakeLook()
PARAMETER p_msg
*-------------------------------------------------------------------
* Set up the public variables for the moving window and initilize
* the coordinates.
*-------------------------------------------------------------------
   PUBLIC gn_uptop
   PUBLIC gn_uplft
   PUBLIC gn_lobot
   PUBLIC gn_lorgt
   PUBLIC gn_wintyp
   PUBLIC gn_maxlo

   PUBLIC gn_moveup
   PUBLIC gn_sizeup
   PUBLIC gn_movedn
   PUBLIC gn_sizedn
   PUBLIC gn_movert
   PUBLIC gn_sizert
   PUBLIC gn_movelt
   PUBLIC gn_sizelt
   PUBLIC gn_home
   PUBLIC gn_top
   PUBLIC gn_end
   PUBLIC gn_bottom

   gn_moveup = 1
   gn_sizeup = 2
   gn_movedn = 3
   gn_sizedn = 4
   gn_movert = 5
   gn_sizert = 6
   gn_movelt = 7
   gn_sizelt = 8
   gn_home   = 9
   gn_top    = 10
   gn_end    = 11
   gn_bottom = 12

   ln_argc = Whatpara("drawbox", p_msg)
   IF ln_argc = 1
      gn_uptop =  5
      gn_uplft = 10
      gn_lobot = 18
      gn_lorgt = 70
   ELSE
      gn_uptop = VAL(drawbox[2])
      gn_uplft = VAL(drawbox[3])
      gn_lobot = VAL(drawbox[4])
      gn_lorgt = VAL(drawbox[5])
   ENDIF
   RELEASE drawbox
RETURN
*-- EOP: Init_Coord WITH p_msg


PROCEDURE Create_Win && UDS - MakeLook()
*-------------------------------------------------------------------
* Create the moving window and activate it.
*-------------------------------------------------------------------
   IF gc_status = "ON"
      IF "43" $ SET("DISPLAY")
         gn_maxlo = 40
      ELSE
         gn_maxlo = 21
      ENDIF
   ELSE
      IF "43" $ SET("DISPLAY")
         gn_maxlo = 43
      ELSE
         gn_maxlo = 24
      ENDIF
   ENDIF

   DEFINE WINDOW drawbox ;
      FROM gn_uptop,gn_uplft TO gn_lobot,gn_lorgt &gn_wintyp
   ACTIVATE WINDOW drawbox

RETURN
*-- EOP: Create_Win



FUNCTION MakeHelp   && UDF - Create User Help Files
*-----------------------------------------------------------------------------
*-- Notes......: Creates Help files (.dbf, .dbt, .mdx) for FORM.GEN v1.1
*-- Files......: makehelp.str, makehelp.scr, makehelp.fmt, makehelp.dbf,
*-- ...........: makehelp.dbt, makehelp.mdx
*-----------------------------------------------------------------------------

   PRIVATE lc_escape, lc_dbf, esc, lc_makehlp, lc_message, lc_cursor,;
           lc_alias

   DO talkoff

   lc_catalog = SET("CATALOG")
   lc_cursor = SET("CURSOR")
   lc_safety = SET("SAFETY")
   lc_escape = SET("ESCAPE")
   lc_alias = ALIAS()
   ln_fcount = FLDCOUNT()

   SELECT 2 &&  So format file will not try to be invoked

   SAVE SCREEN TO makehelp

   SET CURSOR OFF
   SET CATALOG OFF
   SET ESCAPE OFF
   SET SAFETY OFF

   DEFINE WINDOW makehelp FROM  12,9 TO 18,69 DOUBLE
   ACTIVATE WINDOW makehelp

   CLEAR

   *-- Build Help file name
   lc_dbf = lc_alias
   IF LEN(lc_dbf) > 6
      lc_dbf = LEFT( lc_dbf, 6)
   ENDIF

   lc_dbf = lc_dbf +"_H"

   IF FILE( (lc_dbf + ".dbf") )

      lc_message = "Do you want to edit help for " + lc_alias+ " (Y/N)"
      lc_makehlp = "YES"

      @ 2, CENTER( lc_message,56) SAY lc_message GET lc_makehlp;
         PICTURE "@M YES,NO "

      SET CURSOR ON
      READ
      SET CURSOR OFF

      IF lc_makehlp = "NO"
         DO make_exit
         RETURN .T.
      ENDIF

      USE ( lc_dbf )
      COUNT TO ln_fldcnt

      IF ln_fcount <> ln_fldcnt        && Are the field counts the same

         *-- Check for a change in the structure
         SET ORDER TO fld_name

         SELECT (lc_alias)             && Original dbf call from the form

         COPY TO ___old STRUCTURE EXTENDED

         SELECT SELECT()
         USE ___old ALIAS OLD

         INDEX ON field_name TAG fld
         GO TOP

         SCAN
            IF .NOT. SEEK( field_name, lc_dbf)
               SELECT (lc_dbf)
               APPEND BLANK
               REPLACE fld_name WITH old->field_name
               SELECT old
            ENDIF
         ENDSCAN

         USE IN old                    && Close the work file
         ERASE ___old.dbf              && Remove temporary work files
         ERASE ___old.mdx

         SELECT (lc_dbf)               && Select the Help file again
         SET ORDER TO
      ENDIF
      GO TOP

   ELSE

      *-- Start Help file build process

      SELECT (lc_alias)                          && Go back to OPEN .dbf for the FORM

      COPY STRU EXTENDED TO ___temp
      USE ___temp IN 3
      SELECT 2

      USE Makehelp                               && Use the HELP file structure
      CLEAR

      @ 2,0
      @ 2,1 SAY " Creating: "+lc_dbf +" Help file"
      mv = INKEY(1)

      *-- Copy the Help structure to the new help file
      COPY STRUCTURE TO (lc_dbf)
      USE (lc_dbf) IN SELECT()

      *-- Add field names from data file into help file
      SELECT 3
      @ 2,0
      @ 2,1 SAY " Adding field names to "+lc_dbf +" from " + lc_alias
      mv = INKEY(1)

      SCAN WHILE .NOT. EOF()
         SELECT (lc_dbf)
         APPEND BLANK
         SELECT 3
         REPLACE &lc_dbf.->fld_name WITH field_name
      ENDSCAN

      *-- Index New help file by fld_name
      SELE (lc_dbf)

      SET TALK ON
      INDEX ON fld_name TAG fld_name
      SET TALK OFF

   ENDIF

   SELE (lc_dbf)
   mv = INKEY(1)
   SET ORDER TO
   GO TOP

   *-- Allow help builder to enter help text
   IF FILE("MAKEHELP.FMT")
      SET FORM TO Makehelp
   ENDIF
   SET MESSAGE TO "You can now enter your help text - CTRL-W to exit"
   EDIT
   SET FORM TO
   SET MESSAGE TO

   *-- Search for deleted records on exit of Editing Help
   LOCATE FOR DELETED()
   IF FOUND()
       ACTIVATE WINDOW makehelp
       @ 2,0
       @ 2,1 SAY "Removing deleted records"
       PACK
       DEACTIVATE WINDOW makehelp
   ENDIF

   *-- Clean up environment
   USE
   USE IN 3
   USE IN 2
   ERASE ___TEMP.DBF

   DO make_exit

RETURN .T.
*-- EOF: MakeHelp()


PROCEDURE Make_Exit && UDS - MakeHelp()
   SET SAFETY &lc_safety.
   SET ESCAPE &lc_escape.
   SET CURSOR &lc_cursor.
   SET TALK &zz_talk.
   SET CATALOG &lc_catalog.
   RELEASE WINDOW makehelp
   SET MESSAGE TO
   SELECT (lc_alias)
   DO talkon
   Enter = CHR( 13 )
   Home  = CHR( 26 )
   CtrlY = CHR( 25 )
   KEYBOARD Enter + Home + CtrlY + Enter CLEAR
RETURN
*-- EOP: Make_Exit

FUNCTION MakeHelp   && UDF - Create User Help Files
*-----------------------------------------------------------------------------
*-- Notes......: Creates Help files (.dbf, .dbt, .mdx) for FORM.GEN v1.1
*-- Files......: makehelp.str, makehelp.scr, makehelp.fmt, makehelp.dbf,
*-- ...........: makehelp.dbt, makehelp.mdx
*-----------------------------------------------------------------------------

   PRIVATE lc_escape, lc_dbf, esc, lc_makehlp, lc_message, lc_cursor,;
           lc_alias

   DO talkoff

   lc_catalog = SET("CATALOG")
   lc_cursor = SET("CURSOR")
   lc_safety = SET("SAFETY")
   lc_escape = SET("ESCAPE")
   lc_alias = ALIAS()
   ln_fcount = FLDCOUNT()

   SELECT 2 &&  So format file will not try to be invoked

   SAVE SCREEN TO makehelp

   SET CURSOR OFF
   SET CATALOG OFF
   SET ESCAPE OFF
   SET SAFETY OFF

   DEFINE WINDOW makehelp FROM  12,9 TO 18,69 DOUBLE
   ACTIVATE WINDOW makehelp

   CLEAR

   *-- Build Help file name
   lc_dbf = lc_alias
   IF LEN(lc_dbf) > 6
      lc_dbf = LEFT( lc_dbf, 6)
   ENDIF

   lc_dbf = lc_dbf +"_H"

   IF FILE( (lc_dbf + ".dbf") )

      lc_message = "Do you want to edit help for " + lc_alias+ " (Y/N)"
      lc_makehlp = "YES"

      @ 2, CENTER( lc_message,56) SAY lc_message GET lc_makehlp;
         PICTURE "@M YES,NO "

      SET CURSOR ON
      READ
      SET CURSOR OFF

      IF lc_makehlp = "NO"
         DO make_exit
         RETURN .T.
      ENDIF

      USE ( lc_dbf )
      COUNT TO ln_fldcnt

      IF ln_fcount <> ln_fldcnt        && Are the field counts the same

         *-- Check for a change in the structure
         SET ORDER TO fld_name

         SELECT (lc_alias)             && Original dbf call from the form

         COPY TO ___old STRUCTURE EXTENDED

         SELECT SELECT()
         USE ___old ALIAS OLD

         INDEX ON field_name TAG fld
         GO TOP

         SCAN
            IF .NOT. SEEK( field_name, lc_dbf)
               SELECT (lc_dbf)
               APPEND BLANK
               REPLACE fld_name WITH old->field_name
               SELECT old
            ENDIF
         ENDSCAN

         USE IN old                    && Close the work file
         ERASE ___old.dbf              && Remove temporary work files
         ERASE ___old.mdx

         SELECT (lc_dbf)               && Select the Help file again
         SET ORDER TO
      ENDIF
      GO TOP

   ELSE

      *-- Start Help file build process

      SELECT (lc_alias)                          && Go back to OPEN .dbf for the FORM

      COPY STRU EXTENDED TO ___temp
      USE ___temp IN 3
      SELECT 2

      USE Makehelp                               && Use the HELP file structure
      CLEAR

      @ 2,0
      @ 2,1 SAY " Creating: "+lc_dbf +" Help file"
      mv = INKEY(1)

      *-- Copy the Help structure to the new help file
      COPY STRUCTURE TO (lc_dbf)
      USE (lc_dbf) IN SELECT()

      *-- Add field names from data file into help file
      SELECT 3
      @ 2,0
      @ 2,1 SAY " Adding field names to "+lc_dbf +" from " + lc_alias
      mv = INKEY(1)

      SCAN WHILE .NOT. EOF()
         SELECT (lc_dbf)
         APPEND BLANK
         SELECT 3
         REPLACE &lc_dbf.->fld_name WITH field_name
      ENDSCAN

      *-- Index New help file by fld_name
      SELE (lc_dbf)

      SET TALK ON
      INDEX ON fld_name TAG fld_name
      SET TALK OFF

   ENDIF

   SELE (lc_dbf)
   mv = INKEY(1)
   SET ORDER TO
   GO TOP

   *-- Allow help builder to enter help text
   IF FILE("MAKEHELP.FMT")
      SET FORM TO Makehelp
   ENDIF
   SET MESSAGE TO "You can now enter your help text - CTRL-W to exit"
   EDIT
   SET FORM TO
   SET MESSAGE TO

   *-- Search for deleted records on exit of Editing Help
   LOCATE FOR DELETED()
   IF FOUND()
       ACTIVATE WINDOW makehelp
       @ 2,0
       @ 2,1 SAY "Removing deleted records"
       PACK
       DEACTIVATE WINDOW makehelp
   ENDIF

   *-- Clean up environment
   USE
   USE IN 3
   USE IN 2
   ERASE ___TEMP.DBF

   DO make_exit

RETURN .T.
*-- EOF: MakeHelp()


PROCEDURE Make_Exit && UDS - MakeHelp()
   SET SAFETY &lc_safety.
   SET ESCAPE &lc_escape.
   SET CURSOR &lc_cursor.
   SET TALK &zz_talk.
   SET CATALOG &lc_catalog.
   RELEASE WINDOW makehelp
   SET MESSAGE TO
   SELECT (lc_alias)
   DO talkon
   Enter = CHR( 13 )
   Home  = CHR( 26 )
   CtrlY = CHR( 25 )
   KEYBOARD Enter + Home + CtrlY + Enter CLEAR
RETURN
*-- EOP: Make_Exit

PROCEDURE Com_XTab  && Compute CrossTab Baded on Parameters
PARAMETERS p_topfld, p_sidfld, p_calfld, p_calc
*------------------------------------------------------------------
* Compute data normalized form of a relational database 
* file to a spreadsheet-like structure.  It summarizes the 
* data in one field by expressing it in terms of two other 
* fields.
* 
* SYNTAX 
* 
* DO Com_XTab WITH <top field name>, <side field name>, ;
*                  <calc field>, <type calc>
* 
* where <type calc> can be one of the following functions:
* 
*   CNT
*   MAX
*   MIN
*   SUM
* 
* USAGE
* 
* The Com_XTab command handles all records in the active 
* file that match any filter condition placed on the data.
* Com_XTab places the result of the CROSSTAB in a file
* named CROSSTAB.  Com_XTab will also place the column names
* for the <top field name> in a file named COLUMNS.  
* Com_XTab will overwrite these files.
* 
* OPTIONS
* 
* CNT counts the records that match the <top field name>
* and the <side field name>.
* 
* SUM adds together the values of <calc field> that match
* the <top field name> and the <side field name>.
* 
* MAX determines the maximum value of <calc field> for
* matching values of <top field name> and <side field name>.
* 
* MIN determines the minimum value of <calc field> for
* matching values of <top field name> and <side field name>.
* 
* EXAMPLE
* 
* Consider the following database file.
* 
* CAMPING   Name  Item     Price
* -------   ----  -----   ------
*     1     John  Tent    245.00
*     2     Mark  Stove    59.00
*     3     Jane  Heater   75.00
*     4     Mark  Stove    79.00
*     5     Jane  Heater   95.00
*     6     Jane  Tent    325.00
*     7     John  Tent    175.00
*     8     Mark  Stove    89.00
* 
* DO Com_XTab WITH "Item", "Name", "Price", "SUM"
* 
*   will create the following two files:
* 
* CROSSTAB  Name   COL01   COL02   COL03
* --------  ----  ------  ------  ------
*     1     Jane  170.00    0.00  325.00  
*     2     John    0.00    0.00  420.00
*     3     Mark    0.00  227.00    0.00
* 
* The CROSSTAB file will be active in work area 1.
* 
* COLUMNS   Column  TopField
* -------   ------  --------
*     1     COL01   Heater
*     2     COL02   Stove
*     3     COL03   Tent
* 
* The COLUMNS file will be open in work area 2.  The COLUMNS
* file will have an MDX TAG Column on the Column field.  
* 
* COM_XTAB will create a SET FIELDS TO command for each column
* based on the Columns file to get the correct column heading.
* This technique will only work if the resulting column name
* is less than or equal to 10 characters and it contains
* no punctuation or spaces.
* 
* You may use this file in the report designer to place a 
* meaningfull column label for a report.  Before entering
* the report designer execute the command:
*     SET FIELDS TO <Enter>
* 
* SEE ALSO
* 
*------------------------------------------------------------------

*-- Save the current environment
  SET FILTER TO                 && Clear the filter condition if any
  PRIVATE lc_talk
  IF SET("TALK") = "ON"         && Set talk off, but restore it later
    SET TALK OFF
    lc_talk = "ON"
  ELSE
    lc_talk = "OFF"
  ENDIF

  PRIVATE lc_safety
  lc_safety = SET("SAFETY")     && Save the SAFETY state
  SET SAFETY OFF                && and turn it off.

  PRIVATE lc_excl
  lc_excl = SET("EXCLUSIVE")    && Save the EXCLUSIVE state
  SET EXCLUSIVE ON              && and turn it on.

  PRIVATE lc_status
  lc_status = SET("STATUS")     && Save the status bar before turning it off
  SET STATUS OFF

  SET CURSOR OFF
  lc_stat1 = "Determining the number of UNIQUE Records"
  lc_stat2 = "Creating CROSSTAB and COLUMNS DBF files "
  lc_stat3 = "Populating the COLUMNS file             "
  lc_stat4 = "Populating the CROSSTAB file            "
  lc_stat5 = "Creating Pseudo Field Headings          "
  DEFINE WINDOW com_xtab FROM 5,9 TO 13, 70
  DO ShadowG WITH 5, 9, 13, 70
  ACTIVATE WINDOW com_xtab

  @ 0, 20 SAY "Computing CrossTab"
  @ 2, 5 SAY lc_stat1 + + CHR(205) + CHR(205) + CHR(16)
  @ 2, 50 SAY "Working"

*-- Make sure a data file is open
  IF ISBLANK( ALIAS() )
    lc_error = XT_ErrMsg( "No file is in use!", "" )
    DO XT_RestEv
    CANCEL
  ENDIF   

*-- Preserve the order of the file going into crosstab
  lc_order = ORDER()

*-- Strip the alias from the field id it exists
  ln_apos   = AT( "->", p_topfld )  && Alias position, optional       
  IF ln_apos > 0                    && Alias exists, now get the field
    lc_ptopfld = SUBSTR( p_topfld, ln_apos + 2, LEN( p_topfld ) - ln_apos )
  ELSE
    lc_ptopfld = UPPER( p_topfld )
  ENDIF

  ln_apos   = AT( "->", p_sidfld )  && Alias position, optional       
  IF ln_apos > 0                    && Alias exists, now get the field
    lc_psidfld = SUBSTR( p_sidfld, ln_apos + 2, LEN( p_sidfld ) - ln_apos )
  ELSE
    lc_psidfld = UPPER( p_sidfld )
  ENDIF

  ln_apos   = AT( "->", p_calfld )  && Alias position, optional       
  IF ln_apos > 0                    && Alias exists, now get the field
    lc_pcalfld = SUBSTR( p_calfld, ln_apos + 2, LEN( p_calfld ) - ln_apos )
  ELSE
    lc_pcalfld = UPPER( p_calfld )
  ENDIF


*-- Verify the calculation type
  IF .NOT. p_calc $ "SUM,CNT,MAX,MIN,AVG"
    lc_error = XT_ErrMsg( "Calculation type: " + p_calc + ;
                         " is not supported!", "" )
    DO XT_RestEv
    CANCEL
  ENDIF

*-- Compute the number of top and side values
  lc_typetop = TYPE( lc_ptopfld )
  DO CASE
    CASE lc_typetop = "L"
      INDEX ON IIF( &lc_ptopfld., "T", "F" ) TAG topfld UNIQUE
    CASE lc_typetop = "C"
      INDEX ON UPPER( &lc_ptopfld. ) TAG topfld UNIQUE
    CASE lc_typetop $ "NF"
      INDEX ON &lc_ptopfld. TAG topfld UNIQUE
    CASE lc_typetop = "D"
      INDEX ON DTOS( &lc_ptopfld. ) TAG topfld UNIQUE
  ENDCASE

  COUNT TO ln_columns
  IF ln_columns > 254
    lc_error = XT_ErrMsg( "Unique columns for the top exceeds 254", "")
    DELETE TAG topfld
    DO XT_RestEv
    CANCEL
  ENDIF

  lc_typesid = TYPE( lc_psidfld )
  DO CASE
    CASE lc_typesid = "L"
      INDEX ON IIF( &lc_psidfld., "T", "F" ) TAG sidfld UNIQUE
    CASE lc_typesid = "C"
      INDEX ON UPPER( &lc_psidfld. ) TAG sidfld UNIQUE
    CASE lc_typesid $ "NF"
      INDEX ON &lc_psidfld. TAG sidfld UNIQUE
    CASE lc_typesid = "D"
      INDEX ON DTOS( &lc_psidfld. ) TAG sidfld UNIQUE
  ENDCASE

  COUNT TO ln_rows

  @ 2, 50 SAY "Complete"
  @ 3, 5 SAY lc_stat2 + + CHR(205) + CHR(205) + CHR(16)
  @ 3, 50 SAY "Working"

*-- Create the CROSSTAB file to hold the values
  COPY TO _cross STRUCTURE EXTENDED
  SELECT SELECT()
  USE _cross        

*-- Make the calc field's attributes global for use in the SET FIELDS TO
*-- command after the crosstab is created to adjust the column size.
  IF TYPE( "gn_dec" ) <> "U"
    RELEASE gn_dec
  ENDIF
  PUBLIC gn_dec
  IF TYPE( "gn_len" ) <> "U"
    RELEASE gn_len
  ENDIF
  PUBLIC gn_len

*-- Get the attributes for the side field
  LOCATE FOR field_name = UPPER( lc_psidfld )
  ln_lensid = field_len
  ln_decsid = field_dec

*-- Get the attributes for the top field
  LOCATE FOR field_name = UPPER( lc_ptopfld )
  ln_lentop = field_len
  ln_dectop = field_dec

*-- Get the attributes for the calculated column
  LOCATE FOR field_name = UPPER( lc_pcalfld )
  IF p_calc = "CNT"
    gn_len = LEN( ALLTRIM( RECCOUNT() ) )
    gn_dec = 0
  ELSE
    gn_len = field_len
    IF p_calc = "SUM" .AND. gn_len < 16   && Adjust column length if SUM
      gn_len = gn_len + 2                 && calculation is desired
    ENDIF
    gn_dec = field_dec
  ENDIF
  ZAP

*----------------------------------------------------------------------
*-- Create the CROSSTAB file fields
*----------------------------------------------------------------------
*-- Make the Side Column column
  APPEND BLANK
  REPLACE field_name WITH lc_psidfld, ;
          field_type WITH IIF( lc_typesid = "L", "C", lc_typesid ), ;
          field_len  WITH ln_lensid , ;
          field_dec  WITH ln_decsid , ;
          field_idx  WITH "N"

*-- Make the crosstab columns
  ln_col = 1                      && Counter for creating columns
  DO WHILE ln_col <= ln_columns
    lc_colname = "COL" + SUBSTR( STR( 100 + ln_col, 3, 0), 2, 2 )
    APPEND BLANK
    REPLACE field_name WITH lc_colname, ;
            field_type WITH "N"       , ;
            field_len  WITH gn_len, ;
            field_dec  WITH gn_dec    , ;
            field_idx  WITH "N"

    ln_col = ln_col + 1           && Increment column counter
  ENDDO

  CREATE crosstab FROM _cross
  USE crosstab ALIAS crosstab 
  DO CASE
    CASE lc_typesid = "L"
      INDEX ON IIF( &lc_psidfld., "T", "F" ) TAG &lc_psidfld
    CASE lc_typesid = "C"
      INDEX ON UPPER( &lc_psidfld. ) TAG &lc_psidfld
    CASE lc_typesid $ "NF"
      INDEX ON &lc_psidfld. TAG &lc_psidfld
    CASE lc_typesid = "D"
      INDEX ON DTOS( &lc_psidfld. ) TAG &lc_psidfld
  ENDCASE

*----------------------------------------------------------------------
*-- Make the COLUMN file fields
*----------------------------------------------------------------------
  SELECT SELECT()
  USE _cross
  ZAP
  APPEND BLANK
  REPLACE field_name WITH "COLUMN", ;
          field_type WITH "C"     , ;
          field_len  WITH 5       , ;
          field_dec  WITH 0       , ;
          field_idx  WITH "Y"
  APPEND BLANK            
  REPLACE field_name WITH lc_ptopfld, ;
          field_type WITH "C"       , ;
          field_len  WITH ln_lentop , ;
          field_dec  WITH 0         , ;
          field_idx  WITH "N"

  CREATE columns FROM _cross
  USE columns ALIAS columns
  DO CASE
    CASE lc_typetop = "L"
      INDEX ON IIF( &lc_ptopfld., "T", "F" ) TAG &lc_ptopfld
    CASE lc_typetop = "C"
      INDEX ON UPPER( &lc_ptopfld. ) TAG &lc_ptopfld
    CASE lc_typetop $ "NF"
      INDEX ON &lc_ptopfld. TAG &lc_ptopfld
    CASE lc_typetop = "D"
      INDEX ON DTOS( &lc_ptopfld. ) TAG &lc_ptopfld
  ENDCASE

  @ 3, 50 SAY "Complete"
  @ 4, 5 SAY lc_stat3 + + CHR(205) + CHR(205) + CHR(16)
  @ 4, 50 SAY "Working"

*-- Fill in the column file with the UNIQUE values for the top fields
*-- from the source DBF
  SELECT 1
  SET ORDER TO TAG topfld
  ln_col = 1
  SCAN      
    lc_colname =  "COL" + SUBSTR( STR( 100 + ln_col, 3, 0), 2, 2 )
    SELECT columns
    APPEND BLANK
    DO CASE 
      CASE lc_typetop = "C"
        REPLACE column      WITH lc_colname, ;
                &lc_ptopfld WITH &p_topfld
      CASE lc_typetop = "L"
        REPLACE column      WITH lc_colname, ;
                &lc_ptopfld WITH IIF( &p_topfld., "T", "F" )

      CASE lc_typetop $ "NF"
        REPLACE column      WITH lc_colname, ;
                &lc_ptopfld WITH ;
                  ALLTRIM( STR( &p_topfld, ln_lentop, ln_dectop ) )
      CASE lc_typetop = "D"
        REPLACE column      WITH lc_colname, ;
                &lc_ptopfld WITH DTOC( &p_topfld. )
    ENDCASE

    ln_col = ln_col + 1
    SELECT 1
  ENDSCAN

*-- Initialize the crosstab matrix by filling in the side column
*-- with the UNIQUE values from the source DBF
*-- This two pass approach is no faster than filling it in as
*-- the crosstab function is populated.  It has the added advantage
*-- of correctly ordering the side column.
  SELECT 1
  SET ORDER TO TAG sidfld
  SCAN
    SELECT crosstab
    APPEND BLANK
    REPLACE &lc_psidfld WITH ;
            IIF(lc_typesid = "L", ;
                IIF( &p_sidfld, "T", "F" ),;
                &p_sidfld ;
            )
    SELECT 1
  ENDSCAN

  @ 4, 50 SAY "Complete"
  @ 5, 5 SAY lc_stat4 + + CHR(205) + CHR(205) + CHR(16)
  @ 5, 50 SAY "Working"

*-- Compute the matrix - brute force
  SELECT 1
  SET ORDER TO &lc_order          && Return to the original order
*                                 && in the event a FOR condition was
*                                 && placed on the index.
  SET FILTER TO &gc_filter
  SCAN
    IF lc_typesid = "L"
      l_seekval = IIF( &lc_psidfld., "T", "F" )
    ELSE
      IF lc_typesid = "C"
        l_seekval = UPPER( &lc_psidfld )
      ELSE
        l_seekval = &lc_psidfld
      ENDIF
    ENDIF

    IF SEEK( l_seekval, "crosstab" )

      DO CASE
        CASE lc_typetop = "C"
          l_seekval = UPPER( &lc_ptopfld )
        CASE lc_typetop = "L"
          l_seekval = IIF( &lc_ptopfld., "T", "F" )
        CASE lc_typetop $ "NF"
          l_seekval = ALLTRIM( STR( &lc_ptopfld, ln_lentop, ln_dectop ) )
        CASE lc_typetop = "D"
          l_seekval = DTOC( &lc_ptopfld )
      ENDCASE

      IF SEEK( l_seekval, "columns" )
        lc_colname = columns->column
        DO CASE
          CASE p_calc = "SUM"
            REPLACE crosstab->&lc_colname WITH ;
                    &p_calfld + crosstab->&lc_colname
          CASE p_calc = "CNT"
            REPLACE crosstab->&lc_colname WITH ;
                    1 + crosstab->&lc_colname
          CASE p_calc = "MAX"
            REPLACE crosstab->&lc_colname WITH ;
                    MAX( &p_calfld, crosstab->&lc_colname )
          CASE p_calc = "MIN"
            IF crosstab->&lc_colname = 0
              REPLACE crosstab->&lc_colname WITH &p_calfld
            ELSE
              REPLACE crosstab->&lc_colname WITH ;
                      MIN( &p_calfld, crosstab->&lc_colname )
            ENDIF
        ENDCASE
      ENDIF

    ENDIF

  ENDSCAN

  @ 5, 50 SAY "Complete"
  @ 6, 5 SAY lc_stat5 + + CHR(205) + CHR(205) + CHR(16)
  @ 6, 50 SAY "Working"

*-- Remove the UNIQUE Tags on the data file
  DELETE TAG topfld
  DELETE TAG sidfld

*-- Put the CROSSTAB and columns into view
  CLOSE DATABASE
  SELECT 1
  USE crosstab
  USE columns IN 2 ORDER TAG column

*-- Create the field column labels
  SET FIELDS TO &lc_psidfld. /R
  SET FIELDS OFF
  ln_col = 1
  DO WHILE ln_col <= ln_columns
    lc_colname = "COL" + SUBSTR( STR( 100 + ln_col, 3, 0), 2, 2 )
    lc_coltitl = LOOKUP( columns->&lc_ptopfld, lc_colname, columns->column )
    lc_coltitl = XT_ClnTl( (lc_coltitl) )
    SET FIELDS TO &lc_coltitl = ( &lc_colname )
    SET FIELDS OFF
    ln_col = ln_col + 1
  ENDDO
  SET FIELDS ON

  @ 6, 50 SAY "Complete"
  DO XT_RestEv
RETURN
*-- EOP: Com_XTab


PROCEDURE XT_RestEv && UDF - Com_XTab
*------------------------------------------------------------------
* Restore the previous environment
*------------------------------------------------------------------
  SET TALK &lc_talk
  SET SAFETY &lc_safety
  SET EXCLUSIVE &lc_excl
  SET STATUS &lc_status
  SET CURSOR ON
  RELEASE WINDOW com_xtab
  RELEASE gn_len, gn_dec, lc_cursor, lc_status, lc_escape, lc_proc
RETURN
*-- EOP: XT_RestEv


FUNCTION XT_IsFld   && UDS - Com_XTab
PARAMETER p_fldname
*----------------------------------------------------------------------------
* Synopsis:
* 
* XT_isfld( <p_fldname> )
* 
* The IF_FIELD() function strips off the alais, if any, from the field
* <p_fldname> and then calls IsInView() to verify that the field is in the
* current view.
*
*----------------------------------------------------------------------------
  PRIVATE ll_result, ln_fldcnt

  lc_pfield = UPPER( p_fldname )    && Force the field name to upper case
  ln_apos   = AT( "->", p_fldname ) && Alias position, optional
  IF ln_apos > 0                    && Alias exists, now get it
    lc_alchk = SUBSTR( p_fldname, 1, ln_apos - 1 )
    lc_pfield = SUBSTR( p_fldname, ln_apos + 2, LEN( p_fldname ) - ln_apos )
  ENDIF
  lc_exact = SET("EXACT")
  SET EXACT OFF

  ll_result = IsInView( lc_pfield ) && Check to see if field is in view

  SET EXACT &lc_exact

RETURN( ll_result )
*-- EOF: XT_isfld( <p_filename> )


FUNCTION XT_ErrMsg  && UDS - Com_XTab
PARAMETER p_msg, p_pads
*-----------------------------------------------------------------------
* Synopsis:
*
* XT_ErrMsg( <p_msg>, <p_pads> )
*
* The XT_ErrMsg() function will display the message <p_msg> inside of
* a "radio" dialog box.  The user can select on of the comma delimited
* options specified by the expression <p_pads>.  The XT_ErrMsg() function
* will return the option selected by the user.
*
*-----------------------------------------------------------------------
PRIVATE lc_select     && The pad name the user selected

  DEFINE WINDOW XT_ErrMsg FROM 5, 9 TO 11, 71 DOUBLE
  ACTIVATE WINDOW XT_ErrMsg
  IF ISBLANK( p_pads )
    ? p_msg
    ?
    ? "Press any key to continue"
    ln_key = INKEY( 0 )
    lc_select = "CANCEL"
  ELSE
    ? p_msg                        && Stub code
    ?
    ? "Press any key to continue"  && Stub code
    ln_key = INKEY( 0 )            && Stub code
    lc_select = "CANCEL"
  ENDIF
  DEACTIVATE WINDOW XT_ErrMsg
  RELEASE WINDOW XT_ErrMsg 

RETURN( lc_select )
*-- EOF: XT_ErrMsg( <p_msg>, <p_pads> )


FUNCTION XT_ClnTl   && UDS - Com_XTab
PARAMETER p_title
*-----------------------------------------------------------------------
*
* Synopsis:
* 
* XT_ClnTl( <p_title> )
*
* The XT_ClnTl() function will change any characters in the top row
* title column that are not valid field name characters to the 
* underscore "_" character.  If the value for <p_title> begins with
* a numeral, the XT_ClnTl() function will add the "F" character to
* the beginning of <p_title>.  If the value for <p_title> begins 
* with a character other than a numeric or letter, XT_ClnTl() will
* replace it with the "F" character.
*
* Example:
*
* XT_ClnTl("91.92") will equal "F91_92"
* XT_ClnTl("AT&T")  will equal "AT_T"
*
*-----------------------------------------------------------------------
  PRIVATE lc_result, ln_lentitl, ln_cnt, lc_valchars, lc_char

  lc_valchars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ_0123456789"
  lc_val1st = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

  ln_lentitl = LEN( RTRIM( p_title) )  && get the length of the column
  IF ln_lentitl > 10                   && set the length to 10 if greater
    ln_lentitl = 10                    && that the number of chars in a field
  ENDIF

  ln_cnt = 1
  lc_result = ""

*-- Check for a valid first character, if it is not, use a "F" for
*-- field instead.
  lc_char = UPPER( SUBSTR( p_title, ln_cnt, 1 ) )  
  IF .NOT. lc_char $ lc_val1st                     
    p_title = "F" + p_title
    ln_lentitl = ln_lentitl + 1
  ENDIF

*-- Loop through the characters and make the substitution is needed
  DO WHILE ln_cnt <= ln_lentitl
    lc_char = UPPER( SUBSTR( p_title, ln_cnt, 1 ) )
    IF  lc_char $ lc_valchars
      lc_result = lc_result + lc_char
    ELSE
      lc_result = lc_result + "_"
    ENDIF
    ln_cnt = ln_cnt + 1
  ENDDO

RETURN( lc_result )
*-- EOF: XT_ClnTl( <p_title> )


PROCEDURE Layout
PARAMETERS pc_surface, pc_file
*----------------------------------------------------------------------------
* DESCRIPTION
*   Layout will display a OACC Layout popup based on the records contained
*   in Layout.DBF.  Layout will create a popup bar for each record where
*   the SURFACE field matches the value of <pc_surface>.  Layout will
*   run the program name stored in the field, PRG2RUN, when the user selects
*   the popup bar.  Layout will pass both the surface, <pc_surface>, and
*   the design file name, <pc_file>, parameters to the PRG2RUN program.
*
*   Layout will look for the Layout.DBF in the current directory, the
*   dBASE search PATH, and the dBASE HOME() directory.  If Layout cannot
*   locate Layout.DBF, it will display an error message and return back 
*   to the design surface.
*
*   Layout will have TALK OFF when it calls the PRG2RUN and return the
*   TALK back to its original value when it returns to the surface.
*   Layout will clear the popup from the screen and close Layout.dbf
*   before calling the PRG2RUN.
*----------------------------------------------------------------------------
  PRIVATE ll_talk, ll_lfound, lc_prefix

  *---------------
  *-- Set talk off
  *---------------
  IF SET( "TALK" ) = "ON"
    SET TALK OFF
    ll_talk = .T.
  ELSE
    ll_talk = .F.
  ENDIF

  *-------------------------------------------
  *-- Try to find Layout.DBF before opening it
  *-------------------------------------------
  ll_lfound = .F.                       && Track if Layout.DBF was found
  IF FILE( "Layout.DBF" )
    lc_prefix = ""
    ll_lfound = .T.
  ELSE
    lc_prefix = HOME()
    IF FILE( lc_prefix + "Layout.DBF" )
      ll_found = .T.
    ENDIF
  ENDIF

  *---------------------------------------------
  *-- Error out, if the Layout file is not found
  *---------------------------------------------
  IF .NOT. ll_lfound                    
    DO Err_Box WITH "File not found: Layout.dbf", .t.
    IF ll_talk
      SET TALK ON
    ENDIF
    RETURN
  ENDIF

  *-------------------------------------------------------------------
  *-- Open the Layout file and set the key range to the surface values
  *-------------------------------------------------------------------
  ll_exact = SET( "EXACT" ) = "ON"      && Save EXACT state before
  SET EXACT OFF                         && turning EXACT off

  lc_alias = ALIAS()                    && Capture the current ALIAS
  SELECT SELECT()                       && Grab an available workarea
  USE ( lc_prefix + "Layout" ) ORDER dorder
  SET KEY TO pc_surface                 && Look at only this surface
  GO TOP

  *----------------------------------------------------
  *-- Make sure there are menu options for this surface
  *----------------------------------------------------
  IF EOF()
    DO Err_Box WITH "Layout.dbf has no menu options for this surface", .t.
    IF ll_exact
      SET EXACT ON
    ENDIF
    USE
    IF .NOT. ISBLANK( lc_alias )
      SELECT ( lc_alias )
    ENDIF
    IF ll_talk
      SET TALK ON
    ENDIF
    RETURN
  ENDIF

  *-------------------------------------------------------------------------
  *-- Calculate the popup dimensions based on the number of bars and prompts
  *-------------------------------------------------------------------------
  CALCULATE MAX( LEN( TRIM( prompt ) ) ), CNT() TO ln_maxbar, ln_count
  ln_top = 5                            && Row position for the popup
  ln_left = 39 - ( ln_maxbar + 6 ) / 2  && Column for popup to center it
  ln_bottom = ln_top + ln_count + 1     && Bottom row for the popup
  ln_right = ln_left + ln_maxbar + 6    && Right side including two spaces
                                        && on each side of the longest prompt

  DEFINE POPUP Layout FROM ln_top, ln_left TO MIN( ln_bottom, 21 ), ln_right

  *------------------------
  *-- Define the popup bars
  *------------------------
  ln_bar = 1
  SCAN
    DEFINE BAR ln_bar OF Layout PROMPT "  " + TRIM( Prompt )
    ln_bar = ln_bar + 1
  ENDSCAN
  ON SELECTION POPUP Layout DEACTIVATE POPUP

  *----------------------------------
  *-- Activate the popup for the user
  *----------------------------------
  SAVE SCREEN TO Layout
  DO ShadowG WITH ln_top, ln_left, MIN( ln_bottom, 21 ), ln_right
  ACTIVATE POPUP Layout
  RESTORE SCREEN FROM Layout
  RELEASE SCREEN Layout

  *-----------------------------------------------
  *-- Determine which PRG2RUN for the selected bar
  *-----------------------------------------------
  ln_bar = BAR()
  lc_prg2run = ""
  IF ln_bar > 0    
    GO TOP
    SKIP ln_bar - 1
    lc_prg2run = TRIM( prg2run )
  ENDIF

  *--------------------------------------------------------
  *-- Close down the Layout file before running the PRG2RUN
  *--------------------------------------------------------
  USE
  IF .NOT. ISBLANK( lc_alias )
    SELECT ( lc_alias )
  ENDIF
  RELEASE POPUP Layout

  IF .NOT. ISBLANK( lc_prg2run )
    DO &lc_prg2run WITH pc_surface, pc_file
  ENDIF

  *--------------------------------------
  *-- Restore the rest of the environment
  *--------------------------------------
  IF ll_exact
    SET EXACT ON
  ENDIF
  IF ll_talk
    SET TALK ON
  ENDIF

RETURN
*-- EOP: Layout WITH pc_surface, pc_file


PROCEDURE Template
PARAMETERS pc_surface, pc_file
*----------------------------------------------------------------------------
* DESCRIPTION
*   Template will display the available .GEN files for the given design
*   surface using a popup.  The current template has a check mark in
*   the ACTIVE field.  Template displays the GEN files using the value
*   of <pc_surface>.  This value is stored in the DBASE_NAME field in
*   Template.DBF.  If the GEN files or Template.DBF are not in the
*   current directory, Template will check the dBASE HOME() directory.
*
*   The Del key will remove the record from the popup.  Template will
*   mark the record for deletion and rebuild the popup with SET DELETE
*   ON.  Selecting the <Add new GEN file> bar will allow you to add
*   a new GEN file for the surface.
* 
*   Structure for database : template.dbf
*   Number of data records : 10
*   Date of last update    : 07/16/91
*   Field  Field Name  Type       Width    Dec
*       1  ACTIVE      Character      1
*       2  WORK_NAME   Character     12
*       3  DBASE_NAME  Character      6
*       4  DESCRIPT    Character     32
*   ** Total **                   00052
*----------------------------------------------------------------------------
  PRIVATE ll_tfound, ln_bars, lc_prefix, ll_delete
  PRIVATE gl_react, ll_safety

  ll_safety = SET( "SAFETY" ) = "ON"
  SET SAFETY OFF

  ll_tfound = .F.
  ln_bars = 0
  ll_delete = SET( "DELETE" ) = "ON"

  IF FILE( "Template.DBF" )
    lc_prefix = ""
    ll_tfound = .T.
  ELSE
    lc_prefix = HOME()
    IF FILE( lc_prefix + "Template.DBF" )
      ll_found = .T.
    ENDIF
  ENDIF
  IF ll_tfound
    SET DELETE ON
    lc_alias = ALIAS()                  && Capture the current ALIAS
    SELECT SELECT()                     && Grab an available workarea
    USE ( lc_prefix + "Template" )      && Open the template file
    SET FILTER TO Dbase_Name = pc_surface
    GO TOP

    DO Bld_Temp                         && Build the template popup

    gl_react = .T.
    DO WHILE gl_react
      gl_react = .F.
      ON KEY LABEL Del DO Del_Temp
      ACTIVATE POPUP Template
      IF gl_react
        DO Bld_Temp
      ENDIF      
      ON KEY LABEL Del
    ENDDO

    IF BAR() > 0
      IF FILE( lc_prefix + Work_Name )
        ln_rec = RECNO()
        COPY FILE ( lc_prefix + Work_Name ) TO ;
                  ( lc_prefix + TRIM( Dbase_Name ) + ".GEN" )
        BLANK ALL FIELDS Active
        GO ln_rec
        REPLACE Active WITH CHR(251)
      ELSE
        DO Err_Box WITH "File not found: " + lc_prefix + Work_Name
      ENDIF
    ENDIF

    *-- Restore back the environment
    RELEASE POPUP Template
    USE
    IF .NOT. ll_delete
      SET DELETE OFF
    ENDIF
    IF .NOT. ISBLANK( lc_alias )
      SELECT ( lc_alias )
    ENDIF

  ELSE
    DO Err_Box WITH "File does not exist: " + lc_prefix + "Template.DBF"
  ENDIF

  IF ll_safety
    SET SAFETY ON
  ENDIF

RETURN
*-- EOP: Template


PROCEDURE Bld_Temp
*----------------------------------------------------------------------------
* NAME
*   Bld_Temp - Build the template GEN popup
*
*----------------------------------------------------------------------------
  PRIVATE ln_bars

  SET BORDER TO DOUBLE
  DEFINE POPUP Template FROM  5,11 TO 12, 65
  ON SELECTION POPUP Template DO Sel_Temp

  ln_bars = 1

  *-- Define the data bars
  SCAN
    DEFINE BAR ln_bars OF Template PROMPT;
      " " + Active + " " + CHR( 179 ) + ;
      " " + Work_Name + " " + CHR( 179 ) + ;
      " " + Descript + " "
    ln_bars = ln_bars + 1
  ENDSCAN

  *-- Define the append bar
  DEFINE BAR ln_bars OF Template PROMPT;
      " " + SPACE(1) + " " + CHR( 179 ) + ;
      " " + SPACE(12) + " " + CHR( 179 ) + ;
      " " + "<Add new GEN file>             " + " "
  ln_bars = ln_bars + 1

  *-- Define the remaining blank bars
  DO WHILE ln_bars < 7
    DEFINE BAR ln_bars OF Template PROMPT;
      " " + SPACE(1) + " " + CHR( 179 ) + ;
      " " + SPACE(12) + " " + CHR( 179 ) + ;
      " " + SPACE(32) + " " SKIP
    ln_bars = ln_bars + 1
  ENDDO

  SET BORDER TO

RETURN
*-- EOP: Bld_Temp

PROCEDURE Sel_Temp
PARAMETERS pn_bars
*----------------------------------------------------------------------------
* NAME
*   Sel_Temp - Position to the correct record or add one
*
*----------------------------------------------------------------------------
  PRIVATE ln_bar, ln_row, Active, Work_Name, Descript

  ON KEY LABEL Del

  ln_bar = BAR()
  ln_row = ROW()
  IF .NOT. "<Add new GEN file>" $ PROMPT()
    GO TOP
    SKIP ln_bar - 1
    DEACTIVATE POPUP
  ELSE
    GO TOP
    m->Work_Name = SPACE( 12 )
    m->Descript = SPACE( 32 )

    @ ln_row, 17 GET m->Work_Name ;
        MESSAGE "Enter in the name of the .GEN file including it's extension" 
    @ ln_row, 32 GET m->Descript ;
        MESSAGE "Enter in a description that represents the .GEN file"
    READ
    IF READKEY() > 255
      APPEND BLANK
      REPLACE Work_Name  WITH m->Work_Name, ;
              Dbase_Name WITH pc_surface, ;
              Descript   WITH m->Descript
      gl_react = .T.
      DEACTIVATE POPUP
    ENDIF
  ENDIF

RETURN
*-- EOP: Sel_Temp

PROCEDURE Del_Temp
  IF .NOT. "<Add new GEN file>" $ PROMPT()
    GO TOP
    SKIP BAR() - 1
    DELETE
    gl_react = .T.
    DEACTIVATE POPUP
  ENDIF
RETURN
*-- EOP: Del_Temp



