FUNCTION MakeLook   && UDS - Make BROWSE/POPUP Look-Up String
PARAMETER pc_form   && Format file name
*-----------------------------------------------------------------------------
*-- Notes......: Produces Form.gen browse/popup screen in the form designer
*-- Files......: Creates files with a .scm or .scx extension
*-----------------------------------------------------------------------------
  PRIVATE lc_talk, ln_options, lc_form, ln_options, ln_rtn

  IF SET( "TALK") = "ON"
    SET TALK OFF
    lc_talk = "ON"
  ELSE
    lc_talk = "OFF"
  ENDIF

  SET FORMAT TO

  IF PCOUNT() = 0 .OR. ISBLANK( pc_form )
    lc_form = SPACE(8)

    ln_rtn  = StrInBox( 7, 10, "Enter in the save file name: ", ;
                          lc_form, 8, 8 )
    IF ln_rtn = -1 .OR. ISBLANK( lc_form )
      DO Err_Box WITH "MakeLook() will not save the lookup parameters"
    ENDIF
    lc_form = TRIM( UPPER( lc_form ) )
  ELSE
    lc_form = TRIM( UPPER( pc_form ) )
  ENDIF

  lc_form = IIF( ".FMT" $ lc_form, ;
                 LEFT( lc_form, AT( ".FMT", lc_form ) - 1 ) , ;
                 lc_form) + ".scm"

  *-- Session properties
  ln_options = 12                      && Number of options in Makelook
  DECLARE params[3]
  params[1] = .F.                      && Lookup file open for this popup
  params[2] = ""                       && ALIAS of the open lookup file
  params[3] = ALIAS()                  && Current ALIAS that is in USE

  SELECT SELECT()                      && Avoids GETing of the OPEN FORMAT file

  IF FILE( (lc_form) )                     && Design info not stored
    RESTORE FROM ( lc_form ) ADDITIVE      && Restore the User's requests
    params[1] = .t.                        && .dbf already designed
    USE ( dv_lookup[01] )                  && Open up the lookup file
    params[2] = ALIAS()
  ELSE
    *-- Attribute bar titles for the popup
    DECLARE bt_lookup[ln_options]
    bt_lookup[01] = " Lookup file                  "
    bt_lookup[02] = " Return field                 "
    bt_lookup[03] = " Tag for lookup               "
    bt_lookup[04] = " Browse                       "
    bt_lookup[05] = " Fields list                  "
    bt_lookup[06] = " Window coordinates           "
    bt_lookup[07] = " Allow updates to lookup file "
    bt_lookup[08] = " Name of format file          "
    bt_lookup[09] = " Shadow                       "
    bt_lookup[10] = " Permit blank field values    "
    bt_lookup[11] = " Zoom to form                 "
    bt_lookup[12] = " Replace Fields               "

    *-- Attribute bar messages for the popup
    DECLARE mt_lookup[ln_options]
    mt_lookup[01] = "Enter the Lookup File Name for Field Validation"
    mt_lookup[02] = "Enter the Field Value to Return to the Active GET"
    mt_lookup[03] = "Enter the Order Tag for SEEKing"
    mt_lookup[04] = "Toggle Browse or Popup for the Picklist"
    mt_lookup[05] = "Enter the Fields List for the Browse Picklist - OPTIONAL"
    mt_lookup[06] = "Enter the Window Coordinates for Browse Picklist - OPTIONAL"
    mt_lookup[07] = "Allow APPENDing of New Records in the Browse Picklist"
    mt_lookup[08] = "Enter the Name of the FORMAT File for the Browse Picklist - OPTIONAL"
    mt_lookup[09] = "Apply Shadowing Affects to the Picklist"
    mt_lookup[10] = "Allow Blank Data on Return to the Active GET"
    mt_lookup[11] = "Enter the Name of the FORMAT File for the ZOOMed Edit - OPTIONAL"
    mt_lookup[12] = "Allow Additional Replaces to take place during Lookup - OPTIONAL"

    *-- Default values for the popup
    DECLARE dv_lookup[ln_options]
    dv_lookup[01] = SPACE(80)
    dv_lookup[02] = SPACE(10)
    dv_lookup[03] = SPACE(10)
    dv_lookup[04] = "YES"
    dv_lookup[05] = SPACE(80)
    dv_lookup[06] = "14,00 TO 20,79"
    dv_lookup[07] = "NO"
    dv_lookup[08] = SPACE(80)
    dv_lookup[09] = "NO"
    dv_lookup[10] = "YES"
    dv_lookup[11] = SPACE(80)
    dv_lookup[12] = "NO"

    *-- Array for the REPLACE string
    DECLARE ac_replace[4]
    STORE SPACE(254) TO ac_replace[1], ac_replace[2], ac_replace[3], ac_replace[4]

    *-- Action performed then option is selected
    DECLARE ap_lookup[ln_options]
    ap_lookup[01] = "GET"
    ap_lookup[02] = "GET"
    ap_lookup[03] = "GET"
    ap_lookup[04] = "TOGGLE"
    ap_lookup[05] = "GET"
    ap_lookup[06] = "GET"
    ap_lookup[07] = "TOGGLE"
    ap_lookup[08] = "GET"
    ap_lookup[09] = "TOGGLE"
    ap_lookup[10] = "TOGGLE"
    ap_lookup[11] = "GET"
    ap_lookup[12] = "TOGGLE"

    *-- Assist actions in the event of a SHIFT-F1 Pick List
    DECLARE aa_lookup[ln_options]
    aa_lookup[01] = "FILES LIKE *.DBF"
    aa_lookup[02] = "FIELDS"
    aa_lookup[03] = "TAGS"
    aa_lookup[04] = ""
    aa_lookup[05] = "FIELDS CONTINUE"
    aa_lookup[06] = ""
    aa_lookup[07] = ""
    aa_lookup[08] = "FILES LIKE *.FMT"
    aa_lookup[09] = ""
    aa_lookup[10] = ""
    aa_lookup[11] = "FILES LIKE *.FMT"
    aa_lookup[12] = "FIELDS CONTINUE"

  ENDIF

  SET BORDER TO DOUBLE

  DEFINE POPUP lookup FROM 8,9 TO 21,70
  DEFINE BAR  1 OF lookup PROMPT bt_lookup[01] + dis_val( 01 ) ;
    MESSAGE mt_lookup[01]
  DEFINE BAR  2 OF lookup PROMPT bt_lookup[02] + dis_val( 02 ) ;
    MESSAGE mt_lookup[02]
  DEFINE BAR  3 OF lookup PROMPT bt_lookup[03] + dis_val( 03 ) ;
    MESSAGE mt_lookup[03]
  DEFINE BAR  4 OF lookup PROMPT bt_lookup[04] + dis_val( 04 ) ;
    MESSAGE mt_lookup[04]
  DEFINE BAR  5 OF lookup PROMPT bt_lookup[05] + dis_val( 05 ) ;
    MESSAGE mt_lookup[05] ;
    SKIP FOR bt_lookup[04] = "NO"
  DEFINE BAR  6 OF lookup PROMPT bt_lookup[06] + dis_val( 06 ) ;
    MESSAGE mt_lookup[06] ;
    SKIP FOR bt_lookup[04] = "NO"
  DEFINE BAR  7 OF lookup PROMPT bt_lookup[07] + dis_val( 07 ) ;
    MESSAGE mt_lookup[07] ;
    SKIP FOR bt_lookup[04] = "NO"
  DEFINE BAR  8 OF lookup PROMPT bt_lookup[08] + dis_val( 08 ) ;
    MESSAGE mt_lookup[08] ;
    SKIP FOR bt_lookup[04] = "NO"
  DEFINE BAR  9 OF lookup PROMPT bt_lookup[09] + dis_val( 09 );
    MESSAGE mt_lookup[09]
  DEFINE BAR 10 OF lookup PROMPT bt_lookup[10] + dis_val( 10 );
    MESSAGE mt_lookup[10]
  DEFINE BAR 11 OF lookup PROMPT bt_lookup[11] + dis_val( 11 ) ;
    MESSAGE mt_lookup[11]
  DEFINE BAR 12 OF lookup PROMPT bt_lookup[12] + dis_val( 12 ) ;
    MESSAGE mt_lookup[12]

  ON SELECTION POPUP lookup DO hp_lookup

  SET CURSOR OFF  
  ll_ctrlend = .f.
  ON KEY LABEL Ctrl-End DO BailSave

  SAVE SCREEN TO makelook

  gc_status = SET("STATUS")
  SET STATUS OFF
  RESTORE SCREEN FROM makelook

  DO key_vars                          && Assign keystroke variables

  ACTIVATE POPUP lookup

  SET MESSAGE TO "" AT 24
  SET STATUS &gc_status.
  RESTORE SCREEN FROM makelook
  RELEASE SCREEN makelook

  ON KEY LABEL Ctrl-End
  SET CURSOR ON

  IF ll_ctrlend 
    ln_typeahd = SET( "TYPEAHEAD" )
    SET TYPEAHEAD TO 254

    CLEAR TYPEAHEAD

    IF dv_lookup[04] = "YES"           && Set up browse string
      
      KEYBOARD CHR(kn_Enter) + CHR(kn_Home) + CHR(kn_CtrlY) + ["BROWSE"="] + ;
               LOWER( TRIM( dv_lookup[01] ) ) + [->] + ;
               LOWER( TRIM( dv_lookup[02] ) ) + [ ORDER ] + ;
               LOWER( TRIM( dv_lookup[03] ) ) + [ ]

      KEYBOARD IIF( ISBLANK( dv_lookup[05] ), ;
                    "", ;
                    [FIELDS ] + LOWER( ALLTRIM( dv_lookup[05] ) ) + [ ] )  + ;
               IIF( ISBLANK( dv_lookup[06] ), ;
                    "", ;
                    [FROM ] + LOWER( ALLTRIM( dv_lookup[06] ) ) + [ ] )  + ;
               IIF( dv_lookup[07] = "YES", ;
                    [UPDATE ], ;
                    "")

      KEYBOARD IIF( ISBLANK( dv_lookup[08] ) , ;
                    "", ;
                    [FORMAT ] + LOWER( ALLTRIM( dv_lookup[08] ) ) + [ ] )

      KEYBOARD IIF( dv_lookup[12] = "YES", ;
                    [REPLACE ] + ;
                    IIF( LEN( TRIM( ac_replace[1]) + TRIM( ac_replace[2]) +;
                         TRIM( ac_replace[3]) + TRIM( ac_replace[4])) <= 100,;
                            LOWER( ALLTRIM( ac_replace[1] )) + ;
                            LOWER( ALLTRIM( ac_replace[2] )) + ;
                            LOWER( ALLTRIM( ac_replace[3] )) + ;
                            LOWER( ALLTRIM( ac_replace[4] )) + ;
                            + [ ], ;
                            "";
                       ), ;
                    "")

      KEYBOARD IIF( dv_lookup[09] = "YES", ;
                    [SHADOW ], ;
                    "") + ;
               IIF( dv_lookup[10] = "NO", ;
                    [REQ ], ;
                    "")  + ;
               IIF( ISBLANK( dv_lookup[11] ) , ;
                    "", ;
                    [ZOOM ] + LOWER( ALLTRIM( dv_lookup[11] ) ) ) + ["] + ;
                    CHR(kn_Enter)

      *-- Output REPLACE string to file so that Form.gen will read this.
      *-- If it is greater that 100 characters
      IF LEN(TRIM( ac_replace[1]) + TRIM( ac_replace[2]) +;
             TRIM( ac_replace[3]) + TRIM( ac_replace[4])) > 100

          SET DEVICE TO FILE (lc_form + ".scx")
          @ 0,0 SAY ALLTRIM( ac_replace[1]) + ALLTRIM( ac_replace[2]) + ;
                    ALLTRIM( ac_replace[3]) + ALLTRIM( ac_replace[4])
          SET DEVICE TO SCREEN
      ENDIF

    ELSE
      KEYBOARD CHR(kn_Enter) + CHR(kn_Home) + CHR(kn_CtrlY) + ["POPUP"="] + ;
               LOWER( TRIM( dv_lookup[01] ) ) + [->] + ;
               LOWER( TRIM( dv_lookup[02] ) ) + [ ORDER ] + ;
               LOWER( TRIM( dv_lookup[03] ) ) + [ ] + ;
               IIF( dv_lookup[09] = "YES", ;
                    [SHADOW ] , ;
                    "") + ;
               IIF( dv_lookup[10] = "NO", ;
                    [REQ ], ;
                    "")

      KEYBOARD IIF( dv_lookup[12] = "YES", ;
                    [REPLACE ] + ;
                    IIF( LEN( TRIM( ac_replace[1]) + TRIM( ac_replace[2]) +;
                         TRIM( ac_replace[3]) + TRIM( ac_replace[4])) <= 100,;
                            LOWER( ALLTRIM( ac_replace[1] )) + ;
                            LOWER( ALLTRIM( ac_replace[2] )) + ;
                            LOWER( ALLTRIM( ac_replace[3] )) + ;
                            LOWER( ALLTRIM( ac_replace[4] )) + ;
                            + [ ], ;
                            "";
                       ), ;
                    "") + ;
                    IIF( ISBLANK( dv_lookup[11] ) , ;
                         "", ;
                         [ZOOM ] + LOWER( ALLTRIM( dv_lookup[11] ) ) ) + ;
                    ["] + CHR(kn_Enter)
    ENDIF
  ENDIF  && ll_ctrlend

  IF params[1]
    USE                                && Close the file in use
    IF .NOT. ISBLANK( params[3] )
      SELECT &params[3].               && Back to the original workarea
    ELSE
      SELECT 1
    ENDIF
  ENDIF
      
  RELEASE POPUP lookup

  DO rele_vars                      && Get rid of Global Variables

  IF ll_ctrlend
     *-- Get rid of other varialbes we don't want to save the .scm file
     RELEASE params, zz_talk, ll_ctrlend, ln_options, ln_typeahd, gc_status
     SET SAFETY OFF
     SAVE TO ( lc_form ) ALL EXCEPT lc_talk     && Save the User's requests
     SET SAFETY ON
  ENDIF

  RELEASE bt_lookup, dv_lookup, ap_lookup, ac_replace, mt_lookup,;
          aa_lookup, lc_form

  SET TALK &lc_talk.

RETURN( .t. )
*-- EOF: MakeLook( lc_form )


PROCEDURE BailSave  && UDS - Makelook()
*-------------------------------------------------------------------
* Control-End pressed by the user, save that fact and KEYBOARD Esc
* out of the dialog box
*-------------------------------------------------------------------
  ll_ctrlend = .T.
  KEYBOARD CHR( kn_Esc )
RETURN
*-- EOP: BailSave


PROCEDURE Hp_Lookup && UDS - Makelook()
*-------------------------------------------------------------------
* User selected one of the dialog box bars, call the routine to
* handle either a GET or TOGGLE operation.
*-------------------------------------------------------------------
  bar_value = BAR()
  IF ap_lookup[ bar_value ] = "TOGGLE"
    DO bar_togg WITH bar_value
  ELSE
    DO bar_get WITH bar_value
  ENDIF
RETURN 
*-- EOP: Hp_Lookup


PROCEDURE Bar_Togg  && UDS - Makelook()
PARAMETER pn_bn
*-------------------------------------------------------------------
* Toggle a YES / NO bar when the user selected the dialog bar.
*-------------------------------------------------------------------
  dv_lookup[ pn_bn ] = IIF( dv_lookup[ pn_bn ] = "YES", "NO", "YES")
  pc_bn = STR( pn_bn, 2 )

  *-- Handle dimming action based on the BROWSE or POPUP
  IF pn_bn = 4 .AND. dv_lookup[ pn_bn ] = "NO"
    DEFINE BAR  5 OF lookup PROMPT bt_lookup[05] + dis_val( 05 ) SKIP
    DEFINE BAR  6 OF lookup PROMPT bt_lookup[06] + dis_val( 06 ) SKIP
    DEFINE BAR  7 OF lookup PROMPT bt_lookup[07] + dis_val( 07 ) SKIP
    DEFINE BAR  8 OF lookup PROMPT bt_lookup[08] + dis_val( 08 ) SKIP
  ELSE
    IF pn_bn = 4
      DEFINE BAR  5 OF lookup PROMPT bt_lookup[05] + dis_val( 05 );
        MESSAGE mt_lookup[05]
      DEFINE BAR  6 OF lookup PROMPT bt_lookup[06] + dis_val( 06 ) ;
        MESSAGE mt_lookup[06]
      DEFINE BAR  7 OF lookup PROMPT bt_lookup[07] + dis_val( 07 ) ;
        MESSAGE mt_lookup[07]
      DEFINE BAR  8 OF lookup PROMPT bt_lookup[08] + dis_val( 08 ) ;
        MESSAGE mt_lookup[08]
    ENDIF
  ENDIF

  DEFINE BAR &pc_bn OF lookup PROMPT bt_lookup[ pn_bn ] + dv_lookup[ pn_bn ] ;
     MESSAGE mt_lookup [ pn_bn ]

  IF pn_bn = 12 .AND. dv_lookup[ pn_bn ] = "YES"
     lc_colorfld = color("FIELDS")
     lc_colorbox = color("BOX")
     ON KEY LABEL Ctrl-End
     SAVE SCREEN TO replace
     @ 14,10 TO 19,69 DOUBLE COLOR &lc_colorbox.
     SET CURSOR ON
     SET MESSAGE TO "Enter Replace Statements.   Format <f1 WITH f2 [, f3 WITH f4]>"

     DECLARE ac_teplace[4]             && Temporary array for editing replace values
     ac_teplace[1] = ac_replace[1]
     ac_teplace[2] = ac_replace[2]
     ac_teplace[3] = ac_replace[3]
     ac_teplace[4] = ac_replace[4]

     ON KEY LABEL Shift-F1 DO hand_pick WITH pn_bn, VARREAD()
     DO WHILE .T.
        @ 15,11 GET ac_teplace[1] PICTURE "@S58" COLOR &lc_colorfld.
        @ 16,11 GET ac_teplace[2] PICTURE "@S58" COLOR &lc_colorfld.
        @ 17,11 GET ac_teplace[3] PICTURE "@S58" COLOR &lc_colorfld.
        @ 18,11 GET ac_teplace[4] PICTURE "@S58" COLOR &lc_colorfld.
        READ
        IF READKEY() = 270              && CTRL-END, save new values
           ac_replace[1] = ac_teplace[1]
           ac_replace[2] = ac_teplace[2]
           ac_replace[3] = ac_teplace[3]
           ac_replace[4] = ac_teplace[4]
           EXIT
        ENDIF
        IF READKEY() = 12               && Esc, leave old values
           EXIT
        ENDIF
     ENDDO
     RELEASE ac_teplace
     SET CURSOR OFF
     ON KEY LABEL Shift-F1
     ON KEY LABEL Ctrl-End DO BailSave
     SET MESSAGE TO
     RESTORE SCREEN FROM replace
     RELEASE SCREEN replace
  ENDIF
RETURN
*-- EOP: Bar_Togg WITH pn_bn


PROCEDURE Bar_Get   && UDS - MakeLook()
*-------------------------------------------------------------------
* Get the value within the braces
*-------------------------------------------------------------------
PARAMETER pn_bn

  PRIVATE ll_invalid, ll_zoomed, ll_msg, ln_row, ln_col, lc_colorfld

  SET MESSAGE TO "" AT 23

  *-- Set up the Shift-F1 pick list if desired
  IF .NOT. ISBLANK( aa_lookup[ pn_bn ] )
    ON KEY LABEL Shift-F1 DO hand_pick WITH pn_bn, VARREAD()
    ll_msg =  "Pick operators/fields: Shift-F1    Zoom: F9    Accept: " + ;
              CHR(17) + CHR(196) + CHR(217) + "    Cancel: Esc"
  ELSE
    ll_msg =  "Zoom: F9    Accept: " + CHR(17) + CHR(196) + CHR(217) + ;
              "    Cancel: Esc"
  ENDIF

  *-- Set up F9 Zoom key
  ON KEY LABEL F9 DO zoom_get

  IF pn_bn = 6
     *-- Set up F4 Size Box  key
     ON KEY LABEL F4 KEYBOARD( CHR(kn_Home) + CHR(kn_CtrlY) + MakeWind() )
     ll_msg = "Design window: F4   " + ll_msg
  ENDIF

  SET CURSOR ON
  lc_prevval = dv_lookup[ pn_bn ]
  ln_row = ROW()
  ln_col = 39
  lc_colorfld = color("FIELDS")
  ll_zoomed = .f.
  ll_invalid = .t.
  lc_pict = "@S30!"
  @ ln_row, ln_col SAY SPACE( LEN( dis_val( pn_bn ) ) ) COLOR &lc_colorfld
  SAVE SCREEN TO bar_get
  DO WHILE ll_invalid
     @ ln_row, ln_col+1 GET dv_lookup[ pn_bn ] PICTURE (lc_pict) ;
       MESSAGE ll_msg
     READ
     IF ln_row = 21
        RESTORE SCREEN FROM bar_get
     ENDIF
     IF .NOT. ll_zoomed
        DO val_get WITH ll_invalid, pn_bn   && ll_invalid will be set .F. if OK
        ON KEY LABEL F9 DO zoom_get         && Re-enable Zoom when not zoomed
     ELSE
        ll_zoomed = .f.
        ON KEY LABEL F9                     && Prevent Zoom from Zoom for now
        @ ln_row, ln_col SAY space(80) COLOR &lc_colorfld
     ENDIF
  ENDDO

  IF READKEY() <> 12                    && Escape not pressed
    pc_bn = STR( pn_bn, 2 )
    DEFINE BAR &pc_bn OF lookup PROMPT bt_lookup[ pn_bn ] + dis_val( pn_bn );
       MESSAGE mt_lookup[ pn_bn ]
  ELSE
    dv_lookup[ pn_bn ] = lc_prevval
  ENDIF

  SET CURSOR OFF

  ON KEY LABEL F4
  ON KEY LABEL F7
  ON KEY LABEL F9
  ON KEY LABEL Shift-F1

  SET MESSAGE TO mt_lookup[ pn_bn ] AT 24
  RELEASE SCREEN bar_get

RETURN
*-- EOP: Bar_Get WITH pn_bn


FUNCTION MakeWind   && UDS - MakeLook()
*-------------------------------------------------------------------
* Calls the Window "movehand'ler" to create a box and returns 
* the coordinates
*-------------------------------------------------------------------
  PRIVATE lc_string
  lc_string = UPPER( dv_lookup[06])
  lc_string = STUFF( lc_string, AT("TO", lc_string), 2, ",")
RETURN ( movehand( "DOUBLE"+ "," + lc_string ) )
*-- EOF: MakeWind()


PROCEDURE Val_Get   && UDS - MakeLook()
*-------------------------------------------------------------------
* Validate the GET value for the dialog box bar
*-------------------------------------------------------------------
PARAMETER ll_return, pn_bn
  ll_return = .f.
RETURN
*-- EOP: Val_Get WITH ll_return, pn_bn


PROCEDURE Zoom_Get  && UDS - MakeLook()
*-------------------------------------------------------------------
* Handle the user's request to F9 - ZOOM on a GET
*-------------------------------------------------------------------
  ln_row = 21
  ln_col = 0
  lc_pict = "@S80!"
  ll_zoomed = .T.
  KEYBOARD CHR( kn_Enter)
RETURN
*-- EOP: Zoom_Get

FUNCTION Dis_Val    && UDS - MakeLook()
PARAMETER pn_bar
*-------------------------------------------------------------------
* Re-Display the GET value within the braces when the user presses
* the Enter key.
*-------------------------------------------------------------------
  PRIVATE lc_result

  IF ap_lookup[ pn_bar ] = "TOGGLE"
    lc_result = dv_lookup[ pn_bar ]
  ELSE
    IF LEN( ALLTRIM( dv_lookup[ pn_bar ] ) ) > 27
      lc_result = "{" + ;
                  LEFT( ALLTRIM( dv_lookup[ pn_bar ] ), 27 ) + ;
                  "}"
    ELSE
      lc_result = "{" + ALLTRIM( dv_lookup[ pn_bar ] ) + "}"
    ENDIF
  ENDIF
RETURN( lc_result )
*-- EOF: Dis_Val( pn_bar )

PROCEDURE Hand_Pick && UDS - MakeLook()
PARAMETER pn_bn, lc_field
*-------------------------------------------------------------------
* Handle the selection of an item from the various picklists
*-------------------------------------------------------------------

  ON KEY LABEL Shift-F1   && Disable Shift-F1 to prevent recursion

  PRIVATE lc_prompt, lc_window, ln_barnum, ln_tagnum

  lc_prompt = SPACE( 80 )
  lc_window = WINDOW()
  IF .NOT. ISBLANK( lc_window)
     ACTIVATE SCREEN
  ENDIF
  DO CASE                  

    CASE ISBLANK( aa_lookup[ pn_bn ] )
      lc_prompt = ""
      DO Beep

    CASE LEFT( aa_lookup[ pn_bn ], 6 ) = "FIELDS"
      IF params[1]                     && Lookup file is open
        DEFINE POPUP picklist PROMPT STRUCTURE FROM 5, 10
        ON SELECTION POPUP picklist DEACTIVATE POPUP
        IF pn_bn = 12 
           IF UPPER( RIGHT( TRIM( &lc_field), 4 ) ) = "WITH"
              ll_in_with = .T.
              SELECT ( params[2] )
           ELSE
              ll_in_with = .F.
              SELECT ( params[3] )
           ENDIF
        ENDIF

        ACTIVATE POPUP picklist
        lc_prompt = IIF( ISBLANK( PROMPT() ), "", ALLTRIM( PROMPT() ) )
        RELEASE POPUP picklist

        SELECT ( params[2] )           && Return to Correct work area
      ENDIF


    CASE aa_lookup[ pn_bn ] = "TAGS"
      IF params[1]

        IF ISBLANK( MDX( 1 ) )
          ln_barnum = 1
        ELSE
          ln_barnum = 3
          ln_tagnum = 1
          DO WHILE .NOT. ISBLANK( TAG( ln_tagnum ) )
            ln_barnum = ln_barnum + 1
            ln_tagnum = ln_tagnum + 1
          ENDDO
        ENDIF
        ln_newbot = MAX( 7, MIN( 5 + ln_barnum, 17 ) )
        DEFINE POPUP mdxlist FROM 5, 10 TO (ln_newbot), 70

        IF ln_barnum = 1
          DEFINE BAR 1 OF mdxlist PROMPT "NO MDX TAGS EXIST - PRESS Esc" SKIP
        ELSE
          DEFINE BAR 1 OF mdxlist PROMPT "TAG NAME  KEY EXPRESSION" SKIP
          DEFINE BAR 2 OF mdxlist PROMPT REPLICATE( "", 10 ) + CHR(197) +;
                                         REPLICATE( "", 48 ) SKIP
          ln_barnum = 3
          ln_tagnum = 1
          DO WHILE .NOT. ISBLANK( TAG( ln_tagnum ) )
            DEFINE BAR ln_barnum OF mdxlist ;
              PROMPT LEFT( TAG( ln_tagnum ) + SPACE(10), 10 ) + "" + ;
                     UPPER( KEY( ln_tagnum ) )
            ln_barnum = ln_barnum + 1
            ln_tagnum = ln_tagnum + 1
          ENDDO
        ENDIF           

        ON SELECTION POPUP mdxlist DEACTIVATE POPUP
        ACTIVATE POPUP mdxlist                     

        IF BAR() > 2
          lc_prompt = ALLTRIM( LEFT( PROMPT(),10 ) )
        ELSE
          lc_prompt = ""
        ENDIF

        RELEASE POPUP mdxlist

      ENDIF && params[1]

    OTHERWISE  && File Like
      DEFINE POPUP picklist PROMPT &aa_lookup[ pn_bn ] FROM 5, 10
      ON SELECTION POPUP picklist DEACTIVATE POPUP
      ACTIVATE POPUP picklist
      IF .NOT. ISBLANK( PROMPT() )
        lc_prompt = ALLTRIM( PROMPT() )
        *-- Get rid of file extensions and path info
        lc_prompt = TRIM( SUBSTR( lc_prompt, RAT( "\", lc_prompt ) + 1 ) )
        lc_prompt = IIF( ".DBF" $ UPPER( lc_prompt ) .OR. ;
                         ".FMT" $ UPPER( lc_prompt ), ;
                        LEFT( lc_prompt, LEN( lc_prompt ) - 4), ;
                        lc_prompt ;
                       )
        IF AT( "DBF", aa_lookup[ pn_bn ] ) > 0
          USE                          && Close current .dbf file
          params[1] = .t.
          SELECT SELECT()
          USE ( lc_prompt )            && Open up current selected file
          params[2] = ALIAS()
        ENDIF

      ELSE
        lc_prompt = ""
      ENDIF
      RELEASE POPUP picklist

  ENDCASE

  IF .NOT. ISBLANK( lc_prompt )
    ln_typeahd = SET( "TYPEAHEAD" )
    SET TYPEAHEAD TO 254

    IF AT( "CONTINUE", aa_lookup[05] ) > 0
      KEYBOARD IIF(pn_bn <> 12, CHR(kn_End), "" ) + lower( lc_prompt )
      IF pn_bn = 12                    && In "Replace Fields" logic
         KEYBOARD IIF( .NOT. ll_in_with , [ WITH ], [, ]) +;
                  CHR(kn_DownArw) + CHR(kn_UpArw) + CHR(kn_End) + CHR(kn_space);
                  && The Down, Up Arrow force the update of the GET buffer
      ENDIF
    ELSE
      KEYBOARD CHR(kn_Home) + CHR(kn_Home) + CHR(kn_CtrlY) + ;
               lc_prompt + CHR(kn_Enter) CLEAR
    ENDIF

    SET TYPEAHEAD TO ln_typeahd
  ENDIF

  ON KEY LABEL Shift-F1 DO hand_pick WITH pn_bn, VARREAD()
  IF .NOT. ISBLANK( lc_window )
     ACTIVATE WINDOW &lc_window.
  ENDIF
RETURN
*-- EOP: Hand_Pick WITH pn_bn

FUNCTION MoveHand   && UDS - MakeLook()
PARAMETER p_wintype
*-------------------------------------------------------------------
* Handle the user input for keypresses to move the window around
* the screen.
*-------------------------------------------------------------------

   IF TYPE("kn_esc") = "U"
      DO key_vars
   ENDIF

   IF LEFT(p_wintype,6) = "DOUBLE"
      IF LEN(p_wintype) > 6
         DO drawbox WITH "NEW_DOUBLE" + SUBSTR( p_wintype, 7)
      ELSE
         DO drawbox WITH "NEW_DOUBLE"
      ENDIF
   ELSE
      IF LEN(p_wintype) > 6
         DO drawbox WITH "NEW_SINGLE" + SUBSTR( p_wintype, 7)
      ELSE
         DO drawbox WITH "NEW_SINGLE"
      ENDIF
   ENDIF

   ll_f7hit = .t.
   lc_result = ""
   KEYBOARD chr( kn_enter) CLEAR
   @ 1, 1 GET lc_result;
      MESSAGE IIF( ll_f7hit , [Size: Shift-F7], [Drag: F7] ) + ;
      [  Position: ]+CHR(27)+CHR(26)+CHR(25)+CHR(24)+[   Accept: Ctrl-End   Cancel: Esc]
   READ
   ln_key = 0

   DO WHILE ln_key <> kn_Esc .AND. ln_key <> kn_CtrlEnd
      ln_key = INKEY(0)
      DO CASE
         CASE ln_key = kn_F7
            ll_f7hit = .T.
         CASE ln_key = kn_ShftF7
            ll_f7hit = .F.
         CASE ln_key = kn_Home
               DO drawbox WITH gn_home
         CASE ln_key = kn_End
               DO drawbox WITH gn_end
         CASE ln_key = kn_PgUp
               DO drawbox WITH gn_top
         CASE ln_key = kn_PgDn
               DO drawbox WITH gn_bottom
         CASE ln_key = kn_UpArw
            IF ll_f7hit
               DO drawbox WITH gn_moveup
            ELSE
               DO drawbox WITH gn_sizeup
            ENDIF
         CASE ln_key = kn_DownArw
            IF ll_f7hit
               DO drawbox WITH gn_movedn
            ELSE
               DO drawbox WITH gn_sizedn
            ENDIF
         CASE ln_key = kn_RghtArw
            IF ll_f7hit
               DO drawbox WITH gn_movert
            ELSE
               DO drawbox WITH gn_sizert
            ENDIF
         CASE ln_key = kn_LeftArw
            IF ll_f7hit
               DO drawbox WITH gn_movelt
            ELSE
               DO drawbox WITH gn_sizelt
            ENDIF
         CASE ln_key = kn_Esc
            DO drawbox WITH "FREE"
            lc_result = ""
         CASE ln_key = kn_CtrlEnd
            lc_result = TRIM(STR(gn_uptop,2)) + "," + ;
               TRIM(STR(gn_uplft,2)) + " TO " + ;
               TRIM(STR(gn_lobot,2)) + "," + ;
               TRIM(STR(gn_lorgt,2))
            DO drawbox WITH "FREE"
         OTHERWISE
            ?? CHR(7)
      ENDCASE
      IF .NOT. (ln_key = kn_Esc .OR. ln_key = kn_CtrlEnd)
         lc_result = TRIM(STR(gn_uptop,2)) + "," + ;
            TRIM(STR(gn_uplft,2)) + " TO " + ;
            TRIM(STR(gn_lobot,2)) + "," + ;
            TRIM(STR(gn_lorgt,2))
         KEYBOARD CHR( kn_enter) CLEAR
         @ 0, 0 SAY "Window Coordinates: "
         @ 1, 1 GET lc_result;
            MESSAGE IIF( ll_f7hit , [Size: Shift-F7], [Drag: F7] ) + ;
            [  Position: ]+CHR(27)+CHR(26)+CHR(25)+CHR(24)+[   Accept: Ctrl-End   Cancel: Esc]
         READ
         CLEAR GETS
      ENDIF
   ENDDO
RETURN (lc_result)
*-- EOF: MoveHand( p_wintype)

PROCEDURE DrawBox   && UDS - MakeLook()
PARAMETER p_msg
*-------------------------------------------------------------------
* Draw or move the window based on the message passed by MoveHand().
*-------------------------------------------------------------------
IF TYPE("p_msg") = "N"

  DO CASE
    CASE p_msg = gn_sizelt
      IF gn_lorgt - gn_uplft > 6
        gn_lorgt = gn_lorgt - 1
        DO resize
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_sizert
      IF gn_lorgt < 79
        gn_lorgt = gn_lorgt + 1
        DO resize
      ELSE
        DO beep
      ENDIF

    CASE p_msg =  gn_sizeup
      IF gn_lobot - gn_uptop > 5
        gn_lobot = gn_lobot - 1
        DO resize
      ELSE
        DO beep
      ENDIF

    CASE p_msg =  gn_sizedn
      IF gn_lobot < gn_maxlo
        gn_lobot = gn_lobot + 1
        DO resize
      ELSE
        DO Beep
      ENDIF

    CASE p_msg = gn_movelt
      IF gn_uplft > 0
        gn_uplft = gn_uplft - 1
        gn_lorgt = gn_lorgt - 1
        MOVE WINDOW drawbox BY 0,-1
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_moveup
      IF gn_uptop > 0
        gn_uptop = gn_uptop - 1
        gn_lobot = gn_lobot - 1
        MOVE WINDOW drawbox BY -1, 0
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_movedn
      IF gn_lobot < gn_maxlo
        gn_uptop = gn_uptop + 1
        gn_lobot = gn_lobot + 1
        MOVE WINDOW drawbox BY  1, 0
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_movert
      IF gn_lorgt < 79
        gn_uplft = gn_uplft + 1
        gn_lorgt = gn_lorgt + 1
        MOVE WINDOW drawbox BY  0, 1
      ELSE
        DO beep
      ENDIF

    CASE p_msg = gn_home               && Move window to Left side of screen
      IF gn_uplft > 0
        ln_moved = gn_uplft
        gn_lorgt = ABS(gn_lorgt - gn_uplft)
        gn_uplft = 0
        MOVE WINDOW drawbox BY 0,-ln_moved
      ENDIF

    CASE p_msg = gn_top                && Move window to Top of screen
      IF gn_uptop > 0
        ln_moved = gn_uptop
        gn_lobot = ABS(gn_lobot - gn_uptop)
        gn_uptop = 0
        MOVE WINDOW drawbox BY -ln_moved, 0
      ENDIF

    CASE p_msg = gn_end                && Move window to Right side of screen
      IF gn_lorgt < 79
        ln_moved = 79 - gn_lorgt
        gn_uplft = ln_moved
        gn_lorgt = 79
        MOVE WINDOW drawbox BY 0, ln_moved
      ENDIF

    CASE p_msg = gn_bottom             && Move window to Bottom of screen
      IF gn_lobot < gn_maxlo
        ln_moved = gn_maxlo - gn_lobot
        gn_uptop = ln_moved
        gn_lobot = gn_maxlo
        MOVE WINDOW drawbox BY ln_moved, 0
      ENDIF

  ENDCASE
ELSE
  DO CASE
    CASE LEFT(p_msg,10) = "NEW_DOUBLE"
      DO init_coord WITH p_msg

      gn_wintyp = "DOUBLE"

      DO create_win

    CASE LEFT(p_msg,10) = "NEW_SINGLE"
      DO init_coord WITH p_msg

      gn_wintyp = ""

      DO create_win

    CASE p_msg = "FREE"
      DEACTIVATE WINDOW drawbox
      RELEASE WINDOW drawbox
      RELEASE gn_uptop, gn_uplft, gn_lobot, gn_lorgt, gn_maxlo, gn_wintyp,;
              gn_moveup, gn_movedn, gn_movert, gn_movelt, ;
              gn_sizeup, gn_sizedn, gn_sizert, gn_sizelt, ;
              gn_top, gn_bottom, gn_home, gn_end

  ENDCASE
ENDIF
RETURN
*-- EOP: DrawBox WITH p_msg


PROCEDURE ReSize    && UDS - MakeLook()
*-------------------------------------------------------------------
* Re-define the window when the user resizes the window.
*-------------------------------------------------------------------
   DEACTIVATE WINDOW drawbox
   DEFINE WINDOW drawbox ;
      FROM gn_uptop, gn_uplft TO gn_lobot, gn_lorgt &gn_wintyp.
   ACTIVATE WINDOW drawbox
RETURN
*-- EOP: ReSize


PROCEDURE Beep      && UDS - MakeLook()
*-------------------------------------------------------------------
* Send a beep when the user selects an invalid key.
*-------------------------------------------------------------------
   ?? CHR(7)
RETURN
*-- EOP: Beep

PROCEDURE Init_Coord && UDS - MakeLook()
PARAMETER p_msg
*-------------------------------------------------------------------
* Set up the public variables for the moving window and initilize
* the coordinates.
*-------------------------------------------------------------------
   PUBLIC gn_uptop
   PUBLIC gn_uplft
   PUBLIC gn_lobot
   PUBLIC gn_lorgt
   PUBLIC gn_wintyp
   PUBLIC gn_maxlo

   PUBLIC gn_moveup
   PUBLIC gn_sizeup
   PUBLIC gn_movedn
   PUBLIC gn_sizedn
   PUBLIC gn_movert
   PUBLIC gn_sizert
   PUBLIC gn_movelt
   PUBLIC gn_sizelt
   PUBLIC gn_home
   PUBLIC gn_top
   PUBLIC gn_end
   PUBLIC gn_bottom

   gn_moveup = 1
   gn_sizeup = 2
   gn_movedn = 3
   gn_sizedn = 4
   gn_movert = 5
   gn_sizert = 6
   gn_movelt = 7
   gn_sizelt = 8
   gn_home   = 9
   gn_top    = 10
   gn_end    = 11
   gn_bottom = 12

   ln_argc = Whatpara("drawbox", p_msg)
   IF ln_argc = 1
      gn_uptop =  5
      gn_uplft = 10
      gn_lobot = 18
      gn_lorgt = 70
   ELSE
      gn_uptop = VAL(drawbox[2])
      gn_uplft = VAL(drawbox[3])
      gn_lobot = VAL(drawbox[4])
      gn_lorgt = VAL(drawbox[5])
   ENDIF
   RELEASE drawbox
RETURN
*-- EOP: Init_Coord WITH p_msg


PROCEDURE Create_Win && UDS - MakeLook()
*-------------------------------------------------------------------
* Create the moving window and activate it.
*-------------------------------------------------------------------
   IF gc_status = "ON"
      IF "43" $ SET("DISPLAY")
         gn_maxlo = 40
      ELSE
         gn_maxlo = 21
      ENDIF
   ELSE
      IF "43" $ SET("DISPLAY")
         gn_maxlo = 43
      ELSE
         gn_maxlo = 24
      ENDIF
   ENDIF

   DEFINE WINDOW drawbox ;
      FROM gn_uptop,gn_uplft TO gn_lobot,gn_lorgt &gn_wintyp
   ACTIVATE WINDOW drawbox

RETURN
*-- EOP: Create_Win



